SystemOrganization addCategory: #'Seaside/Base-Core'!
SystemOrganization addCategory: #'Seaside/Base-Handlers'!
SystemOrganization addCategory: #'Seaside/Base-Responses'!
SystemOrganization addCategory: #'Seaside/Base-Document'!
SystemOrganization addCategory: #'Seaside/Base-Utilities'!
SystemOrganization addCategory: #'Seaside/Base-Connections'!
SystemOrganization addCategory: #'Seaside/Base-Platform'!
SystemOrganization addCategory: #'Seaside/Base-Info'!
SystemOrganization addCategory: #'Seaside/Session-Core'!
SystemOrganization addCategory: #'Seaside/Session-Preferences'!
SystemOrganization addCategory: #'Seaside/Session-State'!
SystemOrganization addCategory: #'Seaside/Session-Filters'!
SystemOrganization addCategory: #'Seaside/Session-Backtracking'!
SystemOrganization addCategory: #'Seaside/Session-Tests'!
SystemOrganization addCategory: #'Seaside/Session-Utilities'!
SystemOrganization addCategory: #'Seaside/Rendering-Core'!
SystemOrganization addCategory: #'Seaside/Rendering-Builder'!
SystemOrganization addCategory: #'Seaside/Rendering-Callbacks'!
SystemOrganization addCategory: #'Seaside/Component-Core'!
SystemOrganization addCategory: #'Seaside/Component-Tasks'!
SystemOrganization addCategory: #'Seaside/Component-Dialogs'!
SystemOrganization addCategory: #'Seaside/Component-Widgets'!
SystemOrganization addCategory: #'Seaside/Component-Reporting'!
SystemOrganization addCategory: #'Seaside/Component-Configuration'!
SystemOrganization addCategory: #'Seaside/Component-Tools'!
SystemOrganization addCategory: #'Seaside/Component-Tools-Squeak'!
SystemOrganization addCategory: #'Seaside/Component-Utilities'!
SystemOrganization addCategory: #'Seaside/Examples-Test'!
SystemOrganization addCategory: #'Seaside/Examples-Tutorial'!
SystemOrganization addCategory: #'Seaside/Examples-SM'!
SystemOrganization addCategory: #'Seaside/Examples-Store'!
SystemOrganization addCategory: #'Seaside/Examples-Wiki'!
SystemOrganization addCategory: #'Seaside/Component-Views'!

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Utilities'!

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID methodsFor: 'private' stamp: 'ab 7/3/2003 14:57'!
initialize
	1 to: self size do: [:i | self at: i put: (($a to: $z), ($A to: $Z)) atRandom asInteger]! !

!WAExternalID methodsFor: 'private' stamp: 'ab 5/29/2003 00:00'!
printOn: stream
	self do: [:i | stream nextPut: (Character value: i)]! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:53'!
new: aNumber
	^ (super new: aNumber) initialize! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 00:09'!
fromString: aString
	| id |
	id _ super new: aString size.
	aString withIndexDo: [:ea :i | id at: i put: ea asInteger].
	^ id
! !

Object subclass: #WAController
	instanceVariableNames: 'continuation delegate '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Core'!

!WAController class methodsFor: 'as yet unclassified' stamp: 'JF 6/2/2003 14:07'!
registerAsAuthenticatedApplication: appName
	| app user password |
	app _ self registerAsApplication: appName sessionClass: WAAuthenticatedSession.

	[user _ FillInTheBlank
		request: ('Please choose an administrator\username for configuring the application ''', appName asString , '''') withCRs.
	user = ''] whileTrue.
		
	[password _ FillInTheBlank
		request: 'Please enter a password for ', user printString.
	password = ''] whileTrue.
		
	app preferenceAt: #username put: user.
	app preferenceAt: #password put: password.
	
	^ app! !

!WAController methodsFor: 'rendering' stamp: 'ab 6/3/2003 01:17'!
renderActiveControllerWithContext: aContext
	|del|
	del _ self delegate.
	del
		ifNil: [self renderWithContext: aContext]
		ifNotNil: [del renderActiveControllerWithContext: aContext]! !

!WAController methodsFor: 'convenience' stamp: 'ab 2/18/2003 20:30'!
session
	^ WASession currentSession! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 14:08'!
registerAsApplication: appName
	^ self registerAsApplication: appName sessionClass: self defaultSessionClass! !

!WAController methodsFor: 'convenience' stamp: 'ab 2/20/2003 19:41'!
inform: aString
	self call: (WADialog message: aString)
! !

!WAController methodsFor: 'call/answer' stamp: 'ab 6/24/2003 16:10'!
willCall
	^ true! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 14:08'!
defaultSessionClass
	^ WAControllerSession! !

WAController subclass: #WAComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Core'!

WAComponent subclass: #WAPackagePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAPackagePanel methodsFor: 'as yet unclassified' stamp: 'ab 2/2/2003 22:07'!
renderContentOn: html
	html form: [
		html table: [
			PackageManager allManagers do:
				[:ea |
				html tableRowWithLabel: ea packageName
						column: [self renderDirectoryEditorForPackage: ea on: html]]
		]
	].
	html anchorWithAction: [Smalltalk snapshot: true andQuit: false] text: 'Save Image'.! !

!WAPackagePanel methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:31'!
renderDirectoryEditorForPackage: aManager on: html
		html
			attributeAt: 'size' put: 50;
			textInputWithValue: aManager directory fullName
			callback: [:path | aManager directory: (FileDirectory on: path)].
		html space.
		html submitButtonOn: #fileIn of: aManager.! !

WAComponent subclass: #WACounter
	instanceVariableNames: 'count '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WACounter methodsFor: 'method-editor' stamp: ''!
increment
	count _ count + 1! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 01:07'!
initialize
	(self registerAsApplication: 'counter')
! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 23:01'!
initialize
	self session registerObjectForBacktracking: self.
	count _ 0! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
example
	^ self new! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 14:38'!
decrement
  count _ count - 1! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'ab 1/4/2003 22:28'!
renderContentOn: html
	html heading: count.
	html anchorWithAction: [self increment] text: '++'.
	html space.
	html anchorWithAction: [self decrement] text: '--'! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
renderHeaderOn: aRenderer
	aRenderer render: self header! !

WAComponent subclass: #WAExplorer
	instanceVariableNames: 'root tree tabs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAExplorer class methodsFor: 'as yet unclassified' stamp: 'ab 6/3/2003 00:49'!
on: aComponent
	^ self new root: aComponent! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:03'!
style
	^'
#explorer-tree {
	vertical-align: top;
	padding: 10px;
	font-size: 10pt;
	background-color: lightgrey;
	width: 20%;
}

#explorer-contents {
	padding: 10px;
}
'! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:52'!
target: aComponent
	| tabName activeComponent|
	tabName _ tabs contents ifNotNilDo: [:c | c selectedTabName].
	activeComponent _ aComponent activeController.
	tabs contents:
		(WATabPanel withAll:
			(Array
				with: #view -> activeComponent
				with: #source -> (WAPrettyPrinter on: activeComponent)
				with: #inspect -> (WAInspector on: activeComponent))).
				
	tabName ifNotNil: [tabs contents selectTabNamed: tabName].		! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:52'!
root: aComponent
	root _ aComponent.
	tree _ WAComponentTree on: root.
	tree onAnswer: [:c | self target: c].
	self target: root.! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:52'!
renderContentOn: html
	html table: [
		html tableRow:
			[html cssId: 'explorer-tree'.
			html tableData: [html render: tree].
			
			html cssId: 'explorer-contents'.
			html tableData: [html render: tabs contents]]]! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:52'!
initialize
	tabs _ WAStateHolder new! !

WAComponent subclass: #WAInputTest
	instanceVariableNames: 'nilString integer emptyString fraction '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAInputTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:39'!
renderContentOn: html
	html form: [
		html table: [
			html	
				tableHeadings: #(Name Value PrintString);
				tableRowWithLabel: 'Nil String'
					column: [html textInputOn: #nilString of: self]
					column: [html text: nilString printString];
				tableRowWithLabel: 'Empty String'
					column: [html textInputOn: #emptyString of: self]
					column: [html text: emptyString printString];
				tableRowWithLabel: 'Integer'
					column: [html textInputOn: #integer of: self]
					column: [html text: integer printString];
				tableRowWithLabel: 'Fraction'
					column: [html textInputOn: #fraction of: self]
					column: [html text: fraction printString].
		].
		html submitButton.
	]
! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer
	^integer! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString: anObject
	nilString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer: anObject
	integer := anObject! !

!WAInputTest methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 23:04'!
initialize
	nilString _ nil.
	emptyString _ ''.
	integer _ 42.
	fraction _ 1/3.! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString: anObject
	emptyString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString
	^emptyString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString
	^nilString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction: anObject
	fraction := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction
	^fraction! !

WAComponent subclass: #WAApplicationEditor
	instanceVariableNames: 'application '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Configuration'!

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:56'!
renderContentOn: html
	html heading: 'Application: ', application name.
	html form: [
		html text: 'Session Class:'.
		html space.
		html
			selectFromList: self sessionClasses
			selected: application sessionClass
			callback: [:c | application sessionClass: c].
		html space.
		html submitButtonWithAction: [] text: 'OK'.
	].
	html paragraph.
	html form: [
		html table: [	
		
			application preferences do:
				[:pref |
				self renderPreference: pref on: html].
			
			html tableRowWith: [html space].
			html
				tableRowWithLabel: 'Base Path'
				column: [html textInputOn: #basePath of: application].

			html tableRowWith: [html space].
			html attributes alignCenter.
			html tableRowWith: [html submitButtonOn: #done of: self] span: 2.
		]
	]! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 3/20/2003 12:14'!
sessionClasses
	^ (WASession allSubclasses asSortedCollection: [:x :y | x name < y name])! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 11/22/2002 19:26'!
componentClasses
	^ WAComponent allSubclasses asSortedCollection: [:x :y | x name < y name]! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 11/12/2002 01:28'!
application: anApplication
	application _ anApplication! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 01:01'!
done
	self answer! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:56'!
renderPreference: aPreference on: html
	html
		tableRowWithLabel: (html labelForSelector: aPreference key)
		column: aPreference! !

WAComponent subclass: #WAHtmlTest
	instanceVariableNames: 'booleanList message number '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderCheckboxesOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc |
			html text: assoc key; space.
			html checkboxWithValue: assoc value callback: [:b | assoc value: b].
			html break].
		html submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 20:06'!
renderTextInputOn: html
		html form: [
			html text: message.
			html paragraph.
			html textInputWithValue: message callback: [:v | message _ v].
			html submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		html divClass: 'row' with: [
			html divClass: 'left' with: [self perform: selA with: html].
			html divClass: 'left' with: [self perform: selB with: html]
		]]
! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderSelectsOn: html
		html text: number.
		html paragraph.
		html form: [
			html selectFromList: (1 to: 10) selected: number callback: [:i | number _ i].
			html submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 20:07'!
renderZ: html
	html space! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderRadioButtonsOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc | |group|
			group _ html radioGroup.
			html text: assoc key; space.
			html radioButtonInGroup: group selected: assoc value callback: [assoc value: true].
			html radioButtonInGroup: group selected: assoc value not callback: [assoc value: false].
			html break].
		html submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 11/23/2002 12:19'!
style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
'! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderSubmitButtonsOn: html
		html text: number.
		html paragraph.
		html form: [
			(1 to: 10) do:
				[:i |
				html submitButtonWithAction: [number _ i] text: i.
				html space]
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:59'!
renderTextAreaOn: html
		html form: [
			html text: message.
			html paragraph.
			html textAreaWithValue: message callback: [:v | message _ v].
			html break; submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:42'!
allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		remove: #renderContentOn:;
		yourself! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:43'!
initialize
	message _ 'Hello world!!'.
	booleanList _ #(a b c d) collect: [:k | k -> ((Array with: true with: false) atRandom)].
	number _ 10 atRandom.! !

WAComponent subclass: #WAToolFrame
	instanceVariableNames: 'child '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:08'!
renderContentOn: html 
	html divNamed: 'frameContent' with: child.
	self renderToolbarOn: html.! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 9/16/2003 12:57'!
newSession
	self session expire! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 17:30'!
style
^'
	#toolbar {position: fixed; bottom: 0; left: 0; right: 0; margin-top: 40px; padding: 3px; clear: both; background: lightgrey; font-size: 10pt}
	#toolbar-profile {margin-top: 40px; padding: 3px; clear: both; background: lightgrey; font-size: 10pt}
'! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:52'!
tools
	^ WATool allSubclasses! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:19'!
actions
	^ #(newSession configure)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:20'!
configure
	self call: (WAApplicationEditor new application: self session application)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:53'!
openTool: aToolClass
	self call: (WAWindow new
				title: aToolClass title;
				content: (aToolClass new root: child))! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:08'!
renderToolbarOn: html 
	html paragraph.
	html 
		divNamed: 'toolbar'
		with: 
			[self actions do:
				[:ea |
				html anchorOn: ea of: self; space].
			self tools do:
				[:ea |
				html anchorWithAction: [self openTool: ea] text: ea linkText; space].
			html space.
			html text: self session footprint]! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:52'!
contents: aComponent
	child _ aComponent! !

!WAToolFrame class methodsFor: 'as yet unclassified' stamp: 'ab 9/28/2002 11:26'!
on: aComponent
	^ self new contents: aComponent! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 15:26'!
container
	^ child! !

WAComponent subclass: #WASingleClassBrowser
	instanceVariableNames: 'browser '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Tutorial'!

!WASingleClassBrowser methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:44'!
class: aClass
	browser _ Browser new setClass: aClass selector: nil! !

!WASingleClassBrowser methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:32'!
messageView
	^ WAPluggableSelectBox
		on: browser
		list: #messageList
		selected: #messageListIndex
		changeSelected: #messageListIndex:! !

!WASingleClassBrowser methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:49'!
renderContentOn: html
	html heading: browser selectedClassName. 
	html attributeAt: 'width' put: 500.
	html table: [
		html tableRow: [
			html tableData: self categoryView.
			html tableData: self messageView.
			html attributeAt: 'width' put: 500.
			html tableData: [].
		].
		html tableRowWith: [html preformatted: browser contents] span: 3.
	]! !

!WASingleClassBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:37'!
example
	^ self on: WASingleClassBrowser! !

!WASingleClassBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:33'!
on: aClass
	^ self new class: aClass! !

!WASingleClassBrowser methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:31'!
categoryView
	^ WAPluggableSelectBox
		on: browser
		list: #messageCategoryList
		selected: #messageCategoryListIndex
		changeSelected: #messageCategoryListIndex:! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 5/31/2003 15:40'!
renderWithContext: aRenderingContext
	self renderAllOn: (self rendererClass fromContext: aRenderingContext)! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector owner '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
owner: anObject
	owner _ anObject! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector _ aSymbol! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:45'!
renderInput: aSymbol on: html
	html form: [
		html bold: aSymbol capitalized.
		html space.
		html textInputWithValue: '' callback: [:v | self target perform: aSymbol with: v].
	]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:44'!
renderLink: aSymbol on: html
	html anchorOn: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:43'!
renderContentOn: html
	self actions do:
		[:symbol |
		symbol numArgs = 0
			ifTrue: [self renderLink: symbol on: html]
			ifFalse: [self renderInput: symbol on: html]]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:13'!
initialize
	actionsSelector _ #actions! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:17'!
target
	^ owner activeController! !

WAComponent subclass: #WAGeeWeb
	instanceVariableNames: 'allPages components page '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Tutorial'!

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 23:43'!
componentNamed: aString
	^ components at: aString ifAbsentPut: [self perform: aString asSymbol]! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 21:09'!
renderContentOn: html
	self renderPageSelectorOn: html.
	html paragraph.

	html attributes
		cellpadding: 10;
		cellspacing: 0;
		width: '90%';
		height: '80%'.
	html table: [
		self renderPaneOn: html.
	
		page contents = self allPages last
			ifFalse: [html cssId: #nav.
				html tableRowWith: [
					html anchorWithAction: [self nextPage] text: 'next page']].
	].

	self renderPageSelectorOn: html.! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 20:43'!
allPages
	^ allPages ifNil: [allPages _ self collectPageSelectors]! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/21/2003 02:27'!
style
	^ '
		body {background-color: #FFFF99}
		#text {background-color: #F8F8EF}
		#spacer {background-color: #F8F8EF}
		#components {background-color: lightblue}
		.component {}
		#nav a {text-decoration: none}
		#nav {font-weight: bold}
		'! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 22:37'!
renderText: aString on: html
	html text: aString! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:06'!
initialize
	components _ Dictionary new.
	page _ WAStateHolder new contents: self allPages first.! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 20:51'!
renderPageSelectorOn: html
	html cssId: #nav.
	html center: [
		page contents = self allPages first
			ifTrue: [html text: '<<']
			ifFalse: [html anchorWithAction: [self prevPage] text: '<<'].
		self allPages withIndexDo:
			[:ea :i | |text|
			html space.
			text _ ea copyAfter: $e.
			page contents = ea
				ifTrue: [html text: i]
				ifFalse: [html anchorWithAction: [self choosePage: ea] text: i]].
		html space.
		page contents = self allPages last
			ifTrue: [html text: '>>']		
			ifFalse: [html anchorWithAction: [self nextPage] text: '>>'].
	]! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/21/2003 02:39'!
renderComponent: aString on: html
	aString isEmpty ifTrue: [^ self].
	html divClass: 'component' with: (self componentNamed: aString)! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 20:44'!
collectPageSelectors
	^ self class allSelectors asSortedCollection select: [:ea | ea beginsWith: 'page']! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 20:45'!
choosePage: aSymbol
	Transcript cr; show: aSymbol.
	page contents: aSymbol! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 21:09'!
renderPaneOn: html
	| stream |
	stream _ self text readStream.
	[stream atEnd] whileFalse: [
			html attributeAt: 'valign' put: 'top'.
			html tableRow: [
				html attributeAt: 'width' put: 400.
				html cssId: 'text'.
				html tableData: [self renderText: (stream upToAll: '{{') on: html].
				html attributeAt: 'width' put: 20.
				html cssId: 'spacer'.
				html tableData: [].
				html cssId: 'components'.
				html tableData: [self renderComponent: (stream upToAll: '}}') on: html]
			].
		].! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:18'!
nextPage
	self choosePage: (self allPages after: page contents)! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:18'!
prevPage
	self choosePage: (self allPages before: page contents)! !

WAGeeWeb subclass: #WATutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Tutorial'!

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 3/26/2003 16:32'!
page4
	^ 'The final responsibility of a component is to handle presentation.  Each component must implement a <tt>#renderContentOn:</tt> method that describes how it is displayed.  The single parameter to this message is an HtmlRenderer object, which implements many methods for conveniently building html.
	
<b>... more to come ...</b>
'! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 19:17'!
page3
	^ 'The second responsibility of a component is to handle user interface behavior.  This usually means having a method for each link or submit button it displays.  The WACounter class has two such methods: <tt>#increment</tt>, which maps to the ++ link, and <tt>#decrement</tt>, which maps to the -- link.  Their implementations are very simple:
<pre>
<b>increment</b>
  count := count + 1

<b>decrement</b>
  count := count - 1
</pre>
{{counter}}
Methods that are directly mapped to links or buttons are sometimes known as <i>action</i> methods.
<p>
You can use this editor to modify the <tt>#increment</tt> action method.  For example, you can try changing it to
<pre>
<b>increment</b>
  count := count + 2
</pre>
Test your changes with the counter above.
{{incrementEditor}}
'! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 16:12'!
incrementEditor
	^ WAMethodEditor class: WACounter selector: #increment! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 14:59'!
counterInspector
	^ WAInspector on: (self componentNamed: 'counter')! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 22:58'!
flowPage
	^ 'Simple action methods, like <tt>#increment</tt>, simply modify the component''s internal state, or, in a more complex application, interact with the domain model or database.  Action methods may also, however, make calls to other components.  Calling a component is much like a method or subroutine call: the new component takes control for as long as it wants, and is displayed in place of the old one.  Eventually, the new component may return control back to its caller.
{{empty}}
On the right is a counter that has been modified to create and call a simple dialog component as it goes below zero.  The decrement method now looks like this:
<pre>
<b>decrement</b>
count = 0 ifTrue:
  [self call: (WADialog message: ''Going negative'')].
count := count - 1.
</pre>
Clicking the "OK" button on the dialog will return control back to the counter.
{{informCounter}}
Components may also return a value as they return control to their caller.  This value is returned from the <tt>#call:</tt> message send.  For example, WADialog can be configured to present Yes and No buttons to the user, and return a true or false value.  This counter has the following decrement method:
<pre>
<b>decrement</b>
  |dialog|
  count = 0 ifTrue:
  [dialog := WADialog confirmation:
              ''Are you sure you want to go negative?''.
  (self call: dialog)  ifFalse: [^ self]].
		
  count := count - 1
</pre>
{{confirmCounter}}'! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 20:37'!
confirmCounter
	^ WAConfirmingCounter new! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 14:20'!
counter
	^ WACounter new! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 20:40'!
page2
	^
'The first responsibility of a component class is to model user interface state.  This state usually corresponds to what''s being displayed on the screen: for example, the component may be keeping track of which record is being displayed, the current values in a form, or which nodes of a navigation tree are expanded.
{{empty}}
The component on the right, implemented by the WACounter class, has a single piece of state: the value of the numeric counter.
In its class definition, it defines a single instance variable, <tt>count</tt>, to maintain this:
<pre>
WAComponent subclass: #WACounter
	instanceVariableNames: ''count''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Seaside/Examples-Tutorial''
</pre>
{{counter}}

You can see here an inspector on the embedded counter, showing its <tt>count</tt> instance variable (<tt>continuation</tt> and <tt>delegate</tt> are defined in the WAComponent superclass, we''ll ignore them for now).  You''ll notice that as you use the ++ and -- links, <tt>count</tt> tracks the changes.
{{counterInspector}}
'! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 20:29'!
informCounter
	^ WAInformingCounter new! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 13:57'!
empty
	^ ''! !

!WATutorial methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 15:16'!
page1
	^
'Welcome to the Seaside tutorial.  The purpose of this tutorial is to introduce and demonstrate some of Seaside''s features in a dynamic, interactive way.  As you progress through the tutorial, you will get to use, inspect, and modify a set of prebuilt examples and tools.  Each example will appear in the right margin of this page, where you can interact with it at your leisure; explanatory text will appear on the left.
{{empty}}
The central class in the Seaside framework is WAComponent.  Each part of a Seaside user interface is controlled by a separate component subclass.  Some components may be very small, modelling a navigation control or specialized form input.  Larger components might model an entire page, and would embed many smaller subcomponents within themselves.  Seaside applications are built through the interactions of many such large components.
<p>
Embedded to the right is the "hello world" of components: a simple counter.  Over the next few pages of this tutorial we will be examining this component class in detail.
{{counter}}
'! !

!WAGeeWeb methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:16'!
text
	^ self perform: page contents! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:09'!
initialize
	stack _ #().
	self session registerObjectForBacktracking: self.! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:09'!
renderContentOn: html
	stack isEmpty ifTrue: [^ self].
	
	html divNamed: 'path' with: [
		stack allButLast do:
			[:assoc |
			html anchorWithAction: [self choose: assoc] text: assoc key.
			html text: ' >> '].
		
		html bold: stack last key].! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack _ stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:16'!
choose: anAssociation
	| newStack |
	newStack _ Array new writeStream.
	stack do:
		[:ea |
		newStack nextPut: ea.
		ea == anAssociation
			ifTrue: [stack _ newStack contents. ^ self]]
! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:36'!
header
	^ nil! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 5/31/2003 15:40'!
rendererClass
	^ WAHtmlRenderer! !

WAComponent subclass: #WABrowser
	instanceVariableNames: 'contents model message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:44'!
selectionInterval
	^ 1 to: 1! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 01:45'!
initialize
	self model: Browser new.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 12/12/2002 00:39'!
renderContentPaneOn: html
	html form: [
		html
			textAreaOn: #contents of: self;
			break;
			submitButtonOn: #accept of: self.
	]! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:50'!
contents
	^contents! !

!WABrowser methodsFor: 'rendering' stamp: 'JF 5/26/2003 13:30'!
style

	^ '

	#contents {width: 80%; height: 200px; font-family: serif; font-size: 12pt}

	'! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:36'!
notify: aString at: location in: sourceStream
	message _ aString allButLast: 3! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:44'!
text
	^ Text fromString: ''! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:42'!
showHelp
	self model plusButtonHit! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:09'!
renderModeButtonsOn: html
	html form: [
		html
			submitButtonWithAction: [ self showInstance ] text: 'instance';
			submitButtonWithAction: [ self showHelp ] text: 'help';
			submitButtonWithAction: [ self showClass ] text: 'class' ]! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
select! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:38'!
showClass
	self model indicateClassMessages! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:39'!
showInstance
	self model indicateInstanceMessages! !

!WABrowser class methodsFor: 'as yet unclassified' stamp: 'ab 9/28/2002 11:35'!
fullOnClass: aClass
	^ self new model: (Browser new setClass: aClass selector: nil)! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
selectFrom: aPos to: anotherPos
! !

!WABrowser methodsFor: 'actions' stamp: 'ab 12/12/2002 00:40'!
accept
	|save|
	Utilities authorInitialsPerSe isEmpty
		ifTrue: [Utilities setAuthorInitials: (self request: 'Please enter your initials:' default: '')].
	message _ nil.
	save _ contents.
	model contents: contents notifying: self.
	contents _ save.
! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 2/16/2003 00:26'!
renderMessageOn: html
	message ifNotNil: [html bold: message]! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/8/2002 22:13'!
model
	^model 
! !

!WABrowser methodsFor: 'actions' stamp: 'ab 10/10/2002 01:45'!
update: aSymbol
	contents _ model contents! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:07'!
model: aBrowserModel
	model _ aBrowserModel.
	model addDependent: self.
	self session registerObjectForBacktracking: model.
	contents _ model contents.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	self
		renderColumnsOn: html;
		renderModeButtonsOn: html;
		renderMessageOn: html;
		renderContentPaneOn: html
	! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:41'!
columnView: columnName
	^WAPluggableSelectBox
		on: model
		list: (columnName, 'List') asSymbol
		selected: (columnName, 'ListIndex') asSymbol
		changeSelected: (columnName, 'ListIndex:') asSymbol! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:54'!
contents: aString
	contents _ aString! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:08'!
renderColumnsOn: html
	|cols|
	cols _ #(systemCategory class messageCategory message)
				collect: [:sel | self columnView: sel].

	html table: [
		html tableRow: [
			cols do: [:ea | html tableData: [html render: ea]].
		]
	]! !

WAComponent subclass: #WAMemoryUse
	instanceVariableNames: 'instances sizes table root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:41'!
totalSize
	^ sizes detectSum: [:ea | ea]! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:36'!
buildTable
	^ WATableReport new
			rowPeriod: 1;
			rowColors: #('lightgrey' 'white');
			rows: sizes keys asSortedCollection;
			columns: 
				(Array with: (WAReportColumn selector: #yourself title: 'Class')
				with: ( WAReportColumn new
					title: 'Instances';
					valueBlock: [:ea | instances at: ea])
				with:
				 (WAReportColumn new
					title: 'Total Size';
					valueBlock: [:ea | sizes at: ea]))
! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:58'!
totalSizeString
	|size unit|
	size _ self totalSize.
	unit _ 'bytes'.
	size > 1024 ifTrue:
		[size _ size / 1024.
		unit _ 'kB'.
		size > 1024 ifTrue:
			[size _ size / 1024.
			unit _ 'MB']].
	^ (size printShowingDecimalPlaces: 1), ' ', unit! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	html bold: self totalInstances asString, ' instances in ', self totalSizeString.
	html render: table.! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 02:18'!
root: anObject
	|segment results|
	root _ anObject.
	segment _ ImageSegment new copyFromRoots: (Array with: root) sizeHint: 100000.
	results _ segment doSpaceAnalysis.
	instances _ results first.
	sizes _ results second.
	table _ self buildTable.! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:42'!
totalInstances
	^ instances detectSum: [:ea | ea]! !

WAComponent subclass: #WAParentTest
	instanceVariableNames: 'parent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:14'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'swap parent' ! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:13'!
parent: aComponent
	parent _ aComponent! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:13'!
go
	parent inform: 'foo'! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
renderFooterOn: aRenderer
	aRenderer render: self footer! !

WAComponent subclass: #WAErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAErrorTest methodsFor: 'as yet unclassified' stamp: 'ab 3/28/2003 16:47'!
renderContentOn: html
	html anchorWithAction: [1/0] text: 'Raise error'! !

WAComponent subclass: #WAExampleBrowser
	instanceVariableNames: 'class selector component hasAnswer answer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:01'!
allClasses
	^ (WAController allSubclasses select: [:ea | ea class selectors anySatisfy: [:s | s beginsWith: self selectorPrefix]])
		asSortedCollection: [:a :b | a name < b name]! !

!WAExampleBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:10'!
initialize
	self registerAsApplication: 'examples'! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:01'!
allSelectors
	^ (class class selectors select: [:s | s beginsWith: self selectorPrefix])
		asSortedCollection! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:33'!
component: aComponent
	component _ aComponent.
	hasAnswer _ false.
	answer _ nil.
	component onAnswer: [:v | hasAnswer _ true. answer _ v].
! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
selectorPrefix
	^ 'example'! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:04'!
selector: aSymbol
	selector _ aSymbol.
	self component: (class perform: selector)! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:54'!
class: aClass
	class _ aClass.
	self selector: self allSelectors first! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:53'!
initialize
	self class: self allClasses first! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:40'!
renderContentOn: html
	html cssId: 'test-forms'; table: [
		html tableRowWith: [
			html form: [
				html selectFromList: self allClasses selected: class callback: [:c | self class: c].
				html submitButtonWithText: 'OK'.
			].
		] with: [
			html form: [
				html selectFromList: self allSelectors selected: selector callback: [:s | self selector: s].
			 	html submitButtonWithText: 'OK'.
			]
		].
	].
	html horizontalRule.
	html render: component.
	hasAnswer ifTrue:
		[html horizontalRule.
		html bold: 'Answer '; text: answer printString]! !

WAComponent subclass: #WACalendarTest
	instanceVariableNames: 'calendar range '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WACalendarTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:59'!
updateCalendar
	calendar startDate: range startDate.
	calendar endDate: range endDate.! !

!WACalendarTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:01'!
initialize
	range _ WADateRangeSelector new.
	range addDependent: self.
	calendar _ WADateTable new rows: #('a' 'b' 'c').
	self updateCalendar.! !

!WACalendarTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:02'!
renderContentOn: html
	html render: range.
	html horizontalRule.
	html render: calendar! !

!WACalendarTest class methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:01'!
initialize
	self registerAsApplication: 'calendar'! !

!WACalendarTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:59'!
update: aSymbol	
	self updateCalendar! !

WAComponent subclass: #WAInspector
	instanceVariableNames: 'path '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:11'!
initialize
	path _ WAPath new! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:28'!
renderMembersOn: html 
	| members |
	members := self object inspectorFields.
	members isEmpty ifTrue: [^self].
	html bold: 'Members: '.
	html attributeAt: 'border' put: 1.
	html table: 
			[members associationsDo: 
					[:assoc | 
					self 
						renderRowForObject: assoc value
						named: assoc key
						on: html]]! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'jf 11/12/2003 16:32'!
renderContentOn: html 
	super renderContentOn: html.
	html render: path.
	html heading: (self object printStringLimitedTo: 50).
	html text: 'Identity Hash: ', self object identityHash asString; break; break.
	self renderMembersOn: html.! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:37'!
canInspect: anObject
	^ anObject isNumber or: [(Array with: nil with: true with: false) includes: anObject]! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:12'!
object
	^ path currentSegment! !

!WAInspector class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 00:21'!
on: anObject
	^ self new object: anObject! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:12'!
renderRowForObject: anObject named: aString on: html
	html tableRow: [
		html tableData: [ 
			(self canInspect: anObject)
				ifTrue: [html text: aString]
				ifFalse: [html anchorWithAction: [self chooseObject: anObject named: aString] text: aString ]
		].
		html tableData: [ html text: (anObject printStringLimitedTo: 100) ]
	]
	! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:11'!
object: anObject 
	path pushSegment: anObject name: anObject printString! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:13'!
chooseObject: anObject named: aString
	path pushSegment: anObject name: aString! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
style
	^ nil! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 6/13/2003 12:27'!
renderHeadElementsOn: aRenderer
	self style ifNotNilDo: [:style | aRenderer linkWithStyle: style].
	self script ifNotNilDo: [:script | aRenderer linkWithScript: script]! !

WAComponent subclass: #WAProfiler
	instanceVariableNames: 'child '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAProfiler methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:09'!
child: aComponent
	child _ aComponent! !

!WAProfiler methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:11'!
renderContentOn: html
	| data |
	data _ SeasidePlatformSupport profileSendsDuring: [html render: child].
	html horizontalRule.
	html preformatted: data.! !

WAComponent subclass: #WAStoreCartView
	instanceVariableNames: 'cart '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:18'!
cart: aCart
	cart _ aCart! !

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
renderRowForCount: aNumber of: anItem on: html 
	| countString |
	countString _ (aNumber = 1) ifTrue: [''] ifFalse: ['(', aNumber asString, ') '].
	html
		tableRowWith: [html anchorWithAction: [cart remove: anItem] text: '-']
		with: countString, anItem title 
		with: (aNumber * anItem price) printStringAsCents! !

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:41'!
renderContentOn: html
	cart isEmpty ifFalse: [^ self].
	html divNamed: 'cart' with: [
		html small: [html bold: 'Your cart:'].
		html table: [
			cart countsAndItems do:
				[:assoc | self renderRowForCount: assoc key of: assoc value on: html ].
			html spacerRow.
			html
				tableRowWith: ''
				with: ''
				with: [html bold: cart totalPrice printStringAsCents].
		]
	]! !

WAComponent subclass: #WAStoreItemView
	instanceVariableNames: 'item '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 16:04'!
trailName
	^ item title! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 23:36'!
renderContentOn: html
	html heading: item title.
	html heading: item subtitle level: 3.
	html paragraph: item description.
	html italic: item price printStringAsCents.
	html form: [
		html submitButtonWithAction: [self addToCart] text: 'Add to Cart'.
		html submitButtonWithAction: [self answer] text: 'Done'.
	]! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:35'!
addToCart
	self session cart add: item! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 14:47'!
item: anItem
	item _ anItem! !

WAComponent subclass: #WSMComponent
	instanceVariableNames: ''
	classVariableNames: 'Sandbox '
	poolDictionaries: ''
	category: 'Seaside/Examples-SM'!

WSMComponent subclass: #WSMIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-SM'!

!WSMIndex methodsFor: 'as yet unclassified' stamp: 'ab 10/24/2002 22:27'!
actions
	^ #(
		'View Package' #viewPackage
		'Edit Package' #editPackage
		'Add Package' #addPackage
		)	! !

!WSMIndex methodsFor: 'as yet unclassified' stamp: 'ab 3/17/2003 14:11'!
addPackage
	| card name |
	name := self request: 'Name of new package:'.
	card := SMCard new initialize name: name.
	self editCard: card.
	card map: self squeakMap id: UUID new.
	card password ifNil: [self setPassword: card].
	self session squeakMap addCard: card.
	self viewCard: card! !

!WSMIndex methodsFor: 'as yet unclassified' stamp: 'JF 5/1/2003 16:32'!
header
	^
'Welcome to the web-based SqueakMap Browser.
<p>
This is an extended example of the Seaside framework.  It requires the SqueakMap package from <a href="http://anakin.bluefish.se:8000/gohu/11">http://anakin.bluefish.se:8000/gohu/11</a>.  Currently, it provides only limited facilities for browsing and editing your local copy of the SqueakMap data.</p>
<p>Some things you might want to look at in the code:</p>

<ul>
<li><b>WSMFrame</b> embodies a common pattern in Seaside applications: it provides a permanent navigation bar around a changing embedded child.</li>
<li><b>WSMCardEditor</b> follows another common pattern - the use of the same component for creating and editing records.</li>
<li><b>WSMCardList>>report</b> demonstrates the new, unfinished reporting component.</li>
<li><b>WSMCardEditor>>renderOn:</b> makes use of some of HtmlRenderer''s convenience methods for generating tables and forms.</li>
<li><b>WSMIndex>>addPackage</b> and other methods are good examples of clean, linear flow, and making appropiate use of the call/answer mechanism.</li>
</ul>

'! !

!WSMIndex methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:18'!
editPackage
	|card|
	card _ self pickACard.
	self editCard: card.
	self viewCard: card.! !

!WSMIndex methodsFor: 'as yet unclassified' stamp: 'ab 10/24/2002 22:31'!
viewPackage
	self viewCard: self pickACard.
! !

WSMComponent subclass: #WSMPasswordCheck
	instanceVariableNames: 'password card '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-SM'!

!WSMPasswordCheck methodsFor: 'as yet unclassified' stamp: 'ab 10/24/2002 22:03'!
card: aCard
	card _ aCard! !

!WSMPasswordCheck methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:14'!
renderContentOn: html
	html heading: 'Please enter the password for ', card name, ':'
		  level: 3.
	html form: [
		html defaultAction: [self checkPassword].
		html passwordInputWithCallback: [:v | password _ v].
		html submitButton
	]! !

!WSMPasswordCheck methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 13:27'!
checkPassword
	(card correctPassword: password)
		ifTrue: [self answer: true]
		ifFalse:
			[self inform: 'Sorry, that password is incorrect.'.
			self answer: false]! !

WSMComponent subclass: #WSMCardList
	instanceVariableNames: 'cards report '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-SM'!

!WSMCardList methodsFor: 'as yet unclassified' stamp: 'ab 3/28/2003 16:01'!
renderContentOn: html
	html heading: 'Choose a package:' level: 3.
	html render: self report.! !

!WSMCardList methodsFor: 'as yet unclassified' stamp: 'ab 10/24/2002 21:38'!
cards: aCollection
	cards _ aCollection! !

!WSMCardList methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:35'!
report
	^ report ifNil:
		[report _
			WATableReport new
				rows: cards;
				columns:
				(Array
					with:
					(WAReportColumn selector: #name title: 'Name' onClick: [:i | self answer: i])
					with: (WAReportColumn selector: #smartVersion title: 'Version')
					 with: (WAReportColumn selector: #summary))]! !

!WSMComponent methodsFor: 'as yet unclassified' stamp: 'ab 3/17/2003 14:16'!
squeakMap
	^ Sandbox ifNil:
		[Sandbox _ (SMSqueakMap newIn: 'sm_sandbox')
						loadFull; 
						yourself].! !

!WSMComponent methodsFor: 'as yet unclassified' stamp: 'ab 3/17/2003 14:11'!
pickACard
	^self call: (WSMCardList new cards: self squeakMap cardsByName)! !

WSMComponent subclass: #WSMPasswordEditor
	instanceVariableNames: 'confirmation password '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-SM'!

!WSMPasswordEditor methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 13:16'!
confirmPassword
	password = confirmation
		ifTrue: [self answer: password]
		ifFalse: [self inform: 'Sorry, the confirmation did not match the password.']! !

!WSMPasswordEditor methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:14'!
renderContentOn: html
	html form: [
		html defaultAction: [self confirmPassword].
		html heading: 'Enter a new password:' level: 3.
		html passwordInputWithCallback: [:v | password _ v].
		html heading: 'Confirm password:' level: 3.
		html passwordInputWithCallback: [:c | confirmation _ c].
		html paragraph.
		html submitButton.
	]! !

!WSMComponent methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:19'!
viewCard: aCard
	self call: (WSMCardViewer new card: aCard).! !

WSMComponent subclass: #WSMCardViewer
	instanceVariableNames: 'card '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-SM'!

!WSMCardViewer methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:19'!
edit
	self editCard: card! !

!WSMCardViewer methodsFor: 'as yet unclassified' stamp: 'ab 10/24/2002 21:57'!
card: aCard
	card _ aCard! !

!WSMCardViewer methodsFor: 'as yet unclassified' stamp: 'ab 3/17/2003 14:11'!
delete
	((self confirm: 'Are you sure you want to delete ' , card name , '?') 
		and: [self checkPasswordFor: card]) 
			ifTrue: 
				[self squeakMap deleteCard: card.
				self answer]! !

!WSMCardViewer methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:40'!
renderContentOn: html
	html heading: card name.
	html preformatted: card fullDescription.
	! !

!WSMCardViewer methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:18'!
actions
	^ #(
		'Edit' #edit
		'Delete' #delete
		)! !

!WSMComponent methodsFor: 'as yet unclassified' stamp: 'ab 10/24/2002 22:32'!
actions
	^ #()! !

!WSMComponent methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:54'!
checkPasswordFor: aCard
	^ aCard password isNil or: [self call: (WSMPasswordCheck new card: aCard)]! !

!WSMComponent methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 13:52'!
setPassword: card
	|pw|
	pw _ self call: WSMPasswordEditor new.
	card setPassword: pw.! !

!WSMComponent methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 13:28'!
editCard: aCard
	(self checkPasswordFor: aCard)
		ifTrue: [self call: (WSMCardEditor new card: aCard)]! !

WSMComponent subclass: #WSMCardEditor
	instanceVariableNames: 'card '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-SM'!

!WSMCardEditor methodsFor: 'as yet unclassified' stamp: 'ab 10/24/2002 22:20'!
card: aCard
	card _ aCard! !

!WSMCardEditor methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 13:52'!
actions
	^ #('Set Password' setPassword)! !

!WSMCardEditor methodsFor: 'as yet unclassified' stamp: 'ab 10/27/2002 00:49'!
save
	self answer: true! !

!WSMCardEditor methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:31'!
renderContentOn: html
	html heading: card name.
	html form: [
		html table: [
			html
				labelledRowForTextInputOn: #name of: card;
				labelledRowForTextInputOn: #summary of: card;
				labelledRowForTextInputOn: #description of: card;
				tableRowWith: [html space];
				labelledRowForTextInputOn: #author of: card;
				labelledRowForTextInputOn: #maintainer of: card;
				tableRowWith: [html space];
				labelledRowForTextInputOn: #currentVersion of: card;
				labelledRowForTextInputOn: #versionComment of: card;
				tableRowWith: [html space];
				labelledRowForTextInputOn: #url of: card;
				labelledRowForTextInputOn: #downloadUrl of: card;
				tableRowWith: [html space];
				attributeAt: 'align' put: 'center';
				tableRowWith: [html submitButtonOn: #save of: self] span: 2.
			] 				
		].! !

!WSMCardEditor methodsFor: 'as yet unclassified' stamp: 'ab 11/24/2002 23:53'!
style
	^ 
	' 
	#name {width: 200px}
	#summary {width: 300px}
	#description {width: 300px}
	#author {width: 200px}
	#maintainer {width: 200px}
	#currentVersion {width: 100px}
	#versionComment {width: 300px}
	#url {width: 300px}
	#downloadUrl {width: 300px}
	'! !

!WSMCardEditor methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 13:52'!
setPassword
	self setPassword: card! !

WAComponent subclass: #WSMFrame
	instanceVariableNames: 'main '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-SM'!

!WSMFrame methodsFor: 'as yet unclassified' stamp: 'ab 10/24/2002 22:34'!
homeClass
	^ WSMIndex! !

!WSMFrame class methodsFor: 'as yet unclassified' stamp: 'ab 3/17/2003 14:17'!
initialize
	self registerAsApplication: 'sm'! !

!WSMFrame methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 15:38'!
performAction: aSymbol
	main activeController perform: aSymbol! !

!WSMFrame methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderNavigationOn: html
	html heading: 'SqueakMap Browser' level: 3.
	
	html divNamed: 'actions' with: [
		self isHome ifFalse:
			[html anchorWithAction: [self home] text: 'Home'.
			html paragraph].
		
		(main activeController respondsTo: #actions) ifTrue:
			[main activeController actions pairsDo:
				[:description :selector |
				html anchorWithAction: [self performAction: selector] text: description.
				html break]]
	]! !

!WSMFrame methodsFor: 'as yet unclassified' stamp: 'ab 11/23/2002 12:58'!
style
^ '/*/*/
	#main {
			float: left;
			width: 70%;
			padding: 2%;
		}

	#nav {
		float: left;
		width: 20%; 	
		padding: 2%;
	}
'! !

!WSMFrame methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 15:50'!
home
	main clearDelegate! !

!WSMFrame methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:33'!
renderContentOn: html
	html divNamed: 'nav' with: [ self renderNavigationOn: html ].
	html divNamed: 'main' with: main.
! !

!WSMFrame methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 15:38'!
isHome
	^ main activeController class = self homeClass! !

!WSMFrame methodsFor: 'as yet unclassified' stamp: 'ab 3/28/2003 16:06'!
initialize
	main _ self homeClass new.
! !

WAComponent subclass: #WAStoreItemList
	instanceVariableNames: 'batcher '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreItemList methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 23:13'!
renderContentOn: html
	html list: batcher batch do:
		[:ea |
		html anchorWithAction: [self choose: ea] text: ea title].
	html render: batcher! !

!WAStoreItemList methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 16:03'!
trailName
	^ 'Item List'! !

!WAStoreItemList methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:18'!
items: aCollection
	batcher _ WABatchedList new items: aCollection; batchSize: 8! !

!WAStoreItemList methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:10'!
choose: anItem
	self call: (WAStoreItemView new item: anItem)! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
renderContentOn: aRenderer! !

WAComponent subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 18:02'!
renderContentOn: html
	html form: [
		html submitButtonWithAction: [self answer: true] text: 'Yes'.
		html space.
		html submitButtonWithAction: [self answer: false] text: 'No'.
	]! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 6/13/2003 12:26'!
script
	^ nil! !

WAComponent subclass: #WADateSelectionDialog
	instanceVariableNames: 'selector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
footer
	^ nil! !

WAComponent subclass: #WAReport
	instanceVariableNames: 'rows '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WAReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:29'!
initialize
	rows _ #().
! !

WAReport subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WATableReport methodsFor: 'rendering' stamp: 'JF 2/3/2003 00:01'!
renderHeaderForColumn: aColumn on: html
	html tableHeading: [
		aColumn canSort
			ifTrue: [
				html anchorWithAction: [self sortColumn: aColumn] text: aColumn title]
			ifFalse: [
				html text: aColumn title]
	]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns _ anArray! !

!WATableReport methodsFor: 'state variables' stamp: 'AC 1/31/2003 11:46'!
sortColumn: anObject 
	anObject = self sortColumn
		ifTrue: [isReversed _ isReversed not]
		ifFalse: [isReversed _ false].
	sortColumn contents: anObject! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'AC 1/31/2003 11:46'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r _ self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:45'!
renderTableHeaderOn: html
	html tableRow: [ columns do: [ :ea | self renderHeaderForColumn: ea on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod _ aNumber! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 1/31/2003 11:26'!
renderRowsOn: html
	self rows withIndexDo: [:row :i | self renderRowNumber: i item: row on: html ]! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:45'!
renderTableFooterOn: html
	html tableRow: [ columns do: [ :ea | self renderFooterForColumn: ea on: html] ]! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:01'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber-1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 5/6/2003 18:31'!
renderContentOn: html
	html attributeAt: 'cellspacing' put: 0; attributeAt: 'cellpadding' put: 5.
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html.
	]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors _ colorArray! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 5/6/2003 18:31'!
renderRowNumber: index item: row on: html
	html attributeAt: 'bgcolor' put: (self colorForRowNumber: index).
	html tableRow: [ columns do: [:ea | self renderColumn: ea row: row on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:06'!
initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 11/11/2002 19:04'!
chooseRow: aRow column: aColumn	
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 2/3/2003 12:41'!
renderColumn: aColumn row: aRow on: html
	|text|
	text _ aColumn textForRow: aRow.
	text isEmpty ifTrue: [text _ '&nbsp;'].
	html tableData: [
		aColumn canChoose
			ifFalse: [html text: text]
			ifTrue: [html anchorWithAction: [self chooseRow: aRow column: aColumn] text: text]
	]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 11/12/2002 14:32'!
renderFooterForColumn: aColumn on: html
	html tableHeading: [ html text: (aColumn totalForRows: rows)]
! !

!WAReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:03'!
rows: anArray
	rows _ anArray! !

WAComponent subclass: #WAVersionUploader
	instanceVariableNames: 'file url '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 8/30/2003 21:21'!
loadFile
	| reader version |
	reader _ MCReader readerClassForFileNamed: file fileName.
	reader ifNil: [self inform: file fileName, ' is not in a known format'].
	version _ reader versionFromStream: file contents asByteArray readStream.
	version load.! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'ab 8/30/2003 20:55'!
saveImage
	Smalltalk snapshot: true andQuit: false! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 8/31/2003 15:49'!
loadURL
	| stream version |
	stream _ url asUrl retrieveContents content asByteArray readStream .
	version _ (MCReader readerClassForFileNamed: url) versionFromStream: stream.
	version load.! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 8/30/2003 21:24'!
renderContentOn: html
	html bold: 'Loaded versions:'.
	html list: MCWorkingCopy allManagers do: [:ea | html text: ea description].
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html bold: 'Load version from file: '; break.
		html fileUploadWithCallback: [:f | file _ f].
		html space.
		html submitButtonWithAction: [self loadFile] text: 'Load'.
	].
	html form: [
		html bold: 'Load version from URL: '; break.
		html attributes size: 60.
		html textInputWithValue: 'http://' callback: [:u | url _ u].
		html space.
		html submitButtonWithAction: [self loadURL] text: 'Load'.
	].
	html anchorWithAction: [self saveImage] text: 'Save Image'. ! !

WAComponent subclass: #WAComponentTree
	instanceVariableNames: 'components root selection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:32'!
renderChildrenOf: aComponent on: html
	html ul: [ 
		aComponent class allInstVarNames do:
			[:name | |ivar|
			ivar _ aComponent instVarNamed: name.
			(ivar isKindOf: WAController)
				ifTrue: [self renderBranch: ivar named: name on: html]
				ifFalse: [((ivar isCollection
							and: [ivar isEmpty not])
							and: [ivar allSatisfy: [:ea | ea isKindOf: WAComponent]])
								ifTrue: [self renderCollection: ivar named: name on: html]]]
	]! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:26'!
root: aComponent
	root _ aComponent.
	selection _ WAStateHolder new contents: root.! !

!WAComponentTree class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 00:20'!
on: aComponent
	^ self new root: aComponent! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:15'!
renderTree: aComponent on: html
	(components includes: aComponent) ifFalse:
		[components add: aComponent.
		self renderChildrenOf: aComponent activeController on: html]! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:50'!
renderLink: aComponent named: nameString on: html
	aComponent == self selection
		ifTrue: [html bold: [html anchorWithAction: [selection contents: aComponent. self answer: aComponent activeController] text: nameString]]
		ifFalse: [html anchorWithAction: [selection contents: aComponent.  self answer: aComponent] text: nameString]! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:38'!
renderCollection: aCollection named: nameString on: html
	html li:
		[html text: nameString.
		html ol: [aCollection do: [:ea | html li: [self renderTree: ea on: html]]]]! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:26'!
renderContentOn: html
	components _ Set new.
	self renderLink: root named: 'root' on: html.
	self renderTree: root on: html! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:21'!
selection
	^ selection contents! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:26'!
renderBranch: aComponent named: nameString on: html
	(components includes: aComponent) ifTrue: [^ self].
	html li: [
		self renderLink: aComponent named: nameString on: html.
		self renderTree: aComponent on: html
	]! !

WAComponent subclass: #WAStoreFront
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreFront methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:29'!
text
	^
'Welcome to the sushiNet online store.
<p>
This is a sample Seaside application.
<p>
Use the search box at the top left to find some results.
Good searches to try might be "tuna", "saba", or "fish".
'! !

!WAStoreFront methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 12:10'!
renderContentOn: html
	html text: self text! !

!WAStoreFront methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 16:04'!
trailName
	^ 'Home'! !

WAComponent subclass: #WATabPanel
	instanceVariableNames: 'selectedTab tabs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WATabPanel class methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:26'!
withAll: aCollection
	^ self new addTabs: aCollection! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 22:02'!
style
	^ ' .TabSelected {background-color: lightblue; font-color: white; width: 95; text-align: center}
		.TabUnselected {background-color: lightgrey; width: 95; text-align: center}
		.TabSpacer {width: 15}
		.TabLine {background-color: lightblue}
	'! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:38'!
addTab: aComponent named: aString
	tabs add: aString -> aComponent! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:49'!
renderTabSpacerOn: html
	html cssClass: 'TabSpacer'; tableData: [html space]! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 15:44'!
selectTabNamed: aString
	selectedTab _ (Dictionary withAll: tabs) at: aString ifAbsent: [self selectedTab]! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:39'!
selectedTab
	^ selectedTab ifNil: [selectedTab _ tabs first value]! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:38'!
initialize
	tabs _ OrderedCollection new! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:50'!
renderTab: aComponent named: aString on: html
	|selected|
	selected _ aComponent == self selectedTab.
	html cssClass: (selected ifTrue: ['TabSelected'] ifFalse: ['TabUnselected']).
	html tableData: [
		selected
			ifTrue: [html text: aString]
			ifFalse: [html anchorWithAction: [selectedTab _ aComponent] text: aString]. 
	]! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 22:01'!
renderContentOn: html
	html table: [
		html tableRow: [
			self renderTabSpacerOn: html.
			tabs do:
				[:ea |
				self renderTabSpacerOn: html.
				self renderTab: ea value named: ea key on: html].
		].
		html cssClass: 'TabLine'.
		html tableRowWith: [html text: '<img width=1 height=1 alt="">'] span: tabs size * 4.
	].
	html break.
	html render: self selectedTab.! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 15:29'!
selectedTabName
	^ (tabs detect: [:assoc | assoc value = self selectedTab]) key! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:24'!
addTabs: aCollection
	aCollection associationsDo:
		[:ea |
		self addTab: ea value named: ea key]! !

WAComponent subclass: #WAMethodEditor
	instanceVariableNames: 'error source selector class '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Tutorial'!

!WAMethodEditor methodsFor: 'as yet unclassified' stamp: 'ab 2/21/2003 02:02'!
notify: anObject at: x in: y! !

!WAMethodEditor methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 16:16'!
setClass: aClass selector: aSymbol
	class _ aClass.
	selector _ aSymbol.
	source _ class sourceCodeAt: selector.
	error _ nil.! !

!WAMethodEditor methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 16:15'!
source: aString	
	source _ aString.
	error _ nil.! !

!WAMethodEditor methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 17:14'!
accept
	| node method |
	(Parser new parseSelector: source) = selector
		ifFalse: [^ error _ 'Please do not change the method name'].
	
	node _ 
		Compiler new compile: source in: class notifying: self ifFail: [^ error _ 'Syntax Error'].
	method _ node generate: #(0 0 0 0).
	
	class addSelector: selector withMethod: method.! !

!WAMethodEditor methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:30'!
renderContentOn: html
	html bold: [html small: error].
	html form: [
		html attributeAt: 'rows' put: 6; attributeAt: 'cols' put: '35'.
		html textAreaWithValue: source callback: [:t | self source: t].
		html break.
		html submitButtonWithAction: [self accept] text: 'Accept'.
	]! !

!WAMethodEditor class methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 15:51'!
class: aClass selector: aSymbol
	^ self new setClass: aClass selector: aSymbol! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:41'!
default: aString
	value _ aString! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:12'!
renderContentOn: html
	html heading: message level: 3.
	html form: [
		html defaultAction: [self answer: value].
		html textInputWithValue: value callback: [:v | value _ v].
		html space.
		html submitButtonWithText: self label.
	]! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:10'!
label: aString
	label _ aString! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:12'!
label
	^ label ifNil: [label _ 'OK']! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:56'!
endDate: aDate
	endDate _ aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 15:12'!
renderContentOn: html
	html attributes border: 1.
	html cssClass: 'DateTable'; table: [
		html tableRow: [self renderMonthHeadingsOn: html].
		html tableRow: [self renderDayHeadingsOn: html].
		rows withIndexDo:
			[:ea :i|
			html tableRow: [self renderRow: ea index: i on: html]].
	]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:22'!
renderHeadingSpacerOn: html
	html tableData: []! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 14:51'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [:date | self renderCellForDate: date row: anObject index: aNumber on: html]	
		separatedBy: [	self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:14'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo:
		[:month :length |
		self renderHeadingSpacerOn: html.
		html
			cssClass: 'MonthHeading';
			attributeAt: 'colspan' put: length;
			tableHeading: [html text: month name; space; text: month year]]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart _ dateSelectionEnd _ aDate. rowSelectionStart _ rowSelectionEnd _ rowIndex]
		ifTrue: [dateSelectionEnd _ aDate. rowSelectionEnd _ rowIndex]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:04'!
selectAll
	dateSelectionStart _ startDate.
	dateSelectionEnd _ endDate.
	rowSelectionStart _ 1.
	rowSelectionEnd _ rows size.! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart _ dateSelectionEnd _ rowSelectionStart _ rowSelectionEnd _ nil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
startRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
endDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
startDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
endRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock _ aBlock! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:41'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	|text|
	html attributeAt: 'bgcolor' put: (self colorForDate: aDate rowIndex: aNumber).
	html attributeAt: 'align' put: 'center'.
	html tableData: [
		text _ cellBlock value: anObject value: aDate.
		html anchorWithAction: [self selectDate: aDate rowIndex: aNumber] text: text.
	]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 14:52'!
datesDo: aBlock separatedBy: monthlyBlock
	| month|
	month _ datesCache first monthIndex.
	datesCache do:
		[:date |
		date monthIndex = month ifFalse: [month _ date monthIndex. monthlyBlock value].
		aBlock value: date].
	monthlyBlock value.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:56'!
startDate: aDate
	startDate _ aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:20'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date | html cssClass: 'DayHeading'; tableHeading: [html text: date dayOfMonth]]
		separatedBy: [self renderHeadingSpacerOn: html]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows _ aCollection! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 14:50'!
renderHeadingForRow: anObject on: html
	html cssClass: 'RowHeading'; tableHeading: [html text: anObject]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:19'!
monthsAndLengthsDo: aBlock
	|count last|
	count _ 0.
	self
		datesDo: [:ea | count _ count + 1. last _ ea]
		separatedBy: [aBlock value: last month value: count.
						count _ 0]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:58'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].
	
	datesCache _ OrderedCollection new.
	date _ startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date _ date next]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

WAComponent subclass: #WAUploadTest
	instanceVariableNames: 'file '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAUploadTest methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 13:32'!
renderContentOn: html
	html heading: 'Upload File'.
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html fileUploadWithCallback: [:f | file _ f].
		html submitButton.
	].

	file ifNotNil:
		[html anchorWithDocument: file contents mimeType: 'application/octet-stream' fileName: file fileName text:file fileName.
		html preformatted: file contents contents].! !

WAComponent subclass: #WAEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAEncodingTest methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:30'!
renderContentOn: html
	| w allChars r |

	w := WriteStream on: String new.
	32 to: 255 do: [ :c |  w nextPut: c asCharacter ].
	allChars := w contents.

	html code: [ 
		html text: 'Start'; break.
		r := ReadStream on: allChars.

		[ r atEnd ] whileFalse: [ 
			html encodeText: (r next: 14);
			break.
		].
		html text: 'End'; 
			  break.
	].
	html text: 'Characters Encoded: '.
	'Hello World' do: [ :c | html encodeCharacter: c ]. 
	html break.
! !

WAComponent subclass: #WAWikiViewer
	instanceVariableNames: 'pageName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Wiki'!

!WAWikiViewer methodsFor: 'as yet unclassified' stamp: 'ab 3/20/2003 13:02'!
initialize
	pageName := WAStateHolder new! !

!WAWikiViewer methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:44'!
rendererClass 
	^ WAWikiRenderer! !

!WAWikiViewer methodsFor: 'state variables' stamp: 'ab 3/20/2003 12:57'!
textAt: page
	^ self session textAt: page! !

!WAWikiViewer class methodsFor: 'as yet unclassified' stamp: 'ab 3/20/2003 13:04'!
initialize
	self registerAsApplication: 'wiki' sessionClass: WAWikiSession! !

!WAWikiViewer methodsFor: 'state variables' stamp: 'ab 12/28/2002 16:09'!
pageName
	^ pageName contents! !

!WAWikiViewer methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:40'!
renderContentOn: wiki 
	wiki
		linkBlock: [:s | self link: s];
		anchorOn: #edit of: self;
		swikify: (self textAt: self pageName)! !

!WAWikiViewer methodsFor: 'state variables' stamp: 'ab 3/20/2003 12:57'!
textAt: page put: aString
	^ self session textAt: page put: aString! !

!WAWikiViewer methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 01:42'!
link: aString 
	self pageName: aString.
	self session addToPath: aString! !

!WAWikiViewer methodsFor: 'as yet unclassified' stamp: 'ab 3/17/2003 14:19'!
edit
	| text |
	text := self 
				call: (WAWikiEditor new text: (self textAt: self pageName)).
	self textAt: self pageName put: text! !

!WAWikiViewer methodsFor: 'state variables' stamp: 'ab 12/28/2002 16:09'!
pageName: anObject 
	pageName contents: anObject! !

WAComponent subclass: #WAWindow
	instanceVariableNames: 'title content style '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:53'!
style
	^ style ifNil: [self defaultStyle]! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 13:19'!
defaultStyle
^ '
	#window-titlebar {background-color: lightblue; margin-bottom: 10px; width: 100%; }
	#window-title { text-align: right; width: 66% }
	#window-close {text-align: right;}
'	! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:52'!
content: aComponent
	content _ aComponent! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title _ aString! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:54'!
style: aString
	style _ aString! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 23:55'!
renderCloseButtonOn: html
	html anchorWithAction: [self answer] text: 'close'! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 13:23'!
renderContentOn: html
	html title: title.
	html attributes at: 'cellspacing' put: 0.
	html table: [
		html cssId: 'window-titlebar'; tableRow: [
				html cssId: 'window-title'; tableData: title.
				html cssId: 'window-close'; tableData: [self renderCloseButtonOn: html].
		].
		html cssId: 'window-content'; tableRowWith: content span: 2.	
	].! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 13:52'!
date: aDate
	day _ aDate dayOfMonth.
	month _ aDate monthIndex.
	year _ aDate year.! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 15:15'!
initialize
	startYear _ Date today year - 1.
	endYear _ Date today year + 5! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:28'!
date
	^ Date newDay: day monthNumber: month year: year! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear _ anInteger! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:32'!
renderValidationErrorOn: html
	html spanClass: 'error' with: 'invalid date'! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:33'!
renderContentOn: html
	html selectFromList: self months selected: month callback: [:i | month _ i] labels: [:ea | self labelForMonth: ea].
	html selectFromList: self days selected: day callback: [:i | day _ i] labels: [:ea | self labelForDay: ea].
	html selectFromList: self yearRange selected: year callback: [:i | year _ i] labels: [:ea | self labelForYear: ea].
	
	self dateIsValid ifFalse: [self renderValidationErrorOn: html].! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear _ anInteger! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

WAComponent subclass: #WATaskFrame
	instanceVariableNames: 'task '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tasks'!

!WATaskFrame methodsFor: 'as yet unclassified' stamp: 'jf 11/10/2003 16:19'!
initialize
	task _ WAPluggableTask withBlock: [:t | self go].
	task onAnswer: [:v | self answer: v]! !

!WATaskFrame methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:44'!
call: aController
	^ task call: aController! !

WATaskFrame subclass: #WAStoreCheckoutTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreCheckoutTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:47'!
go
	^ self confirm: 'Buy ', self session cart totalPrice printStringAsCents, ' worth of sushi?'! !

WATaskFrame subclass: #WAStoreTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:11'!
renderHeaderOn: html
	html table: [
		html cssId: 'banner'; tableRowWith: [
			html divNamed: 'title' with: self title.
			html divNamed: 'subtitle' with: self subtitle.
		]
	]! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:08'!
title
	^ 'sushiNet'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:46'!
go
	self session isolate: [
		self session clearCart.
		self browse.
		[self checkoutSuccessful] whileFalse: [self browse]].
	self confirmCheckout.! !

!WAStoreTask class methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:19'!
initialize
	self registerAsApplication: 'store' sessionClass: WAStoreSession! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:38'!
checkoutSuccessful
	^ self call: (WAStoreCheckoutTask new)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:47'!
confirmCheckout
	self inform: 'Your fish is on its way.'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:11'!
style
	^ '
	body {margin: 0px; font-family: sans-serif}
	table {width: 100%}	
	#banner {background-color: lightblue; text-align: right; padding: 10px; vertical-align: bottom}
	'
! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:38'!
browse
	self call: (WAStoreBrowse new)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:08'!
subtitle
	^ 'fresh, raw fish delivered to your door'! !

!WATaskFrame methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:39'!
renderContentOn: html
	html render: task! !

!WATaskFrame methodsFor: 'as yet unclassified' stamp: 'jf 11/10/2003 16:09'!
go
	self subclassResponsibility! !

WAComponent subclass: #WADispatcherEditor
	instanceVariableNames: 'path dispatcher type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Configuration'!

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:34'!
remove: anEntryPoint
	dispatcher removeEntryPoint: anEntryPoint! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:52'!
entryPointClasses
	^ WAEntryPoint concreteSubclasses! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:49'!
initialize
	dispatcher _ WADispatcher default.
	type _ WAApplication.
	path _ ''.! !

!WADispatcherEditor class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 23:52'!
initialize
	self registerAsAuthenticatedApplication: 'config'! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:48'!
configure: anEntryPoint
	 anEntryPoint configurationComponent ifNotNilDo: [:c | self call: c]! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:13'!
dispatcher: aDispatcher
	dispatcher _ aDispatcher! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:49'!
addEntryPoint
	| entryPoint |
	path isEmpty ifTrue: [^ self inform: 'You must enter a path.'].
	entryPoint _ type new.
	dispatcher registerEntryPoint: entryPoint at: path.
	self configure: entryPoint! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'JF 9/22/2003 20:15'!
clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:33'!
renderRowForEntryPoint: anEntryPoint named: aString on: html
	html
		tableRowWith: [html anchorWithUrl: anEntryPoint basePath do: aString]
		with: [
			html anchorWithAction: [self configure: anEntryPoint] text: 'configure'.
			html space; anchorWithAction: [self remove: anEntryPoint] text: 'remove'.
		].! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:16'!
renderContentOn: html
	html heading: 'Squeak Enterprise Aubergines Server'.
	
	html bold: dispatcher basePath.
	html form: [
		html table: [
			dispatcher entryPoints keysAndValuesDo:
				[:name :each |
				self
					renderRowForEntryPoint: each
					named: name
					on: html].
		]
	].
	html paragraph.
	
	html bold: 'add entry point: '.
	html form: [
		html table: [
			html tableRowWithLabel: 'Path:' column: [html textInputWithValue: '' callback: [:n | path _ n]].
			html tableRowWithLabel: 'Type:' column:
				[html selectFromList: self entryPointClasses selected: type callback: [:c | type _ c] labels: [:ea | ea description].
				html space.
				html submitButtonWithAction: [self addEntryPoint] text: 'Add']
		]
	].

	continuation ifNotNil: [html anchorWithAction: [self answer] text: 'Done'].	
	html preformatted: SeasidePlatformSupport vmStatisticsReportString.
	html anchorWithAction: [self clearCaches] text: 'Clear Caches'.
	! !

WAComponent subclass: #WAWikiEditor
	instanceVariableNames: 'text '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Wiki'!

!WAWikiEditor methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 23:39'!
save
	self answer: text! !

!WAWikiEditor methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:40'!
renderContentOn: html
	html form: [
		html textAreaOn: #text of: self.
		html break.
		html submitButtonOn: #save of: self.
	]! !

!WAWikiEditor methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 23:52'!
style
	^ '#text {width: 80%; height: 80%}'! !

!WAWikiEditor methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 23:39'!
text
	^ text! !

!WAWikiEditor methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 23:39'!
text: aString
	text _ aString! !

WAComponent subclass: #WAMultiCounter
	instanceVariableNames: 'counters '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:07'!
renderContentOn: html
	counters 
		do: [:ea | html render: ea]
		separatedBy: [html horizontalRule]! !

!WAMultiCounter class methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:08'!
initialize
	self registerAsApplication: 'multi'! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:07'!
initialize
	counters _ (1 to: 5) collect: [:i | WACounter new]! !

WAComponent subclass: #WAStoreBrowse
	instanceVariableNames: 'cart cartView main navbar trail '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreBrowse methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 16:03'!
renderContentOn: html
	html table: [
		html tableRowWith: trail span: 3.
		html tableRow: [
			html cssId: 'nav'; tableData: navbar.
			html cssId: 'main'; tableData: main.
			html cssId: 'side'; tableData: cartView.
		]
	]! !

!WAStoreBrowse methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:10'!
style
^ '
	#search {vertical-align: bottom}
	#main {width: 50%; padding: 10px}
	#side {vertical-align: top; }
	#cart {border-style: dashed; border-width: 1; padding: 5px}
	#nav {background-color: lightgrey; vertical-align: top; border-width: 1; padding: 5px; width: 15%; font-size: 12pt}
	#title {font-size: 18pt; font-weight: bold}
	#subtitle {font-size: 9pt; font-style: italic}
	#batch {font-size: 10pt}
'! !

!WAStoreBrowse methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 16:05'!
actions
	| actions |
	actions _ #(search: browse).
	^ self session cart isEmpty
		ifTrue: [actions, #(checkout)]
		ifFalse: [actions]
! !

!WAStoreBrowse methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:10'!
search: aString
	self home.
	main call: (WAStoreSearchTask new search: aString)! !

!WAStoreBrowse methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 15:29'!
home
	main clearDelegate ! !

!WAStoreBrowse methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:11'!
checkout
	self answer.! !

!WAStoreBrowse methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:24'!
browse
	self home.
	main call: (WAStoreItemList new items: WAStoreInventory default allItems)! !

!WAStoreBrowse methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 16:02'!
initialize
	main _ WAStoreFront new.
	navbar _ WANavigationBar new owner: self.
	cartView _ WAStoreCartView new cart: self session cart.
	trail _ WATrail on: main.! !

WAComponent subclass: #WATestTabs
	instanceVariableNames: 'tabs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WATestTabs methodsFor: 'as yet unclassified' stamp: 'avi 9/16/2003 12:57'!
initialize
	tabs _ WATabPanel withAll:
				(OrderedCollection new
					add: ('Input' -> WAInputTest new);
					add: ('Once' -> WAOnceTest new);
					add: ('Html' -> WAHtmlTest new);
					add: ('Encoding' -> WAEncodingTest new);
					add: ('Calendar' -> WACalendarTest new);
					add: ('Error' -> WAErrorTest new);
					add: ('Exception' -> WAExceptionTest new);
					add: ('Closure' -> WAClosureTest new);
					add: ('Transaction' -> WATransactionTest new);
					add: ('Upload' -> WAUploadTest new);
					add: ('Parent' -> (WAParentTest new parent: self));
					yourself)! !

!WATestTabs methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:37'!
renderContentOn: html
	html heading: 'Test Components'.
	html render: tabs! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 2/17/2003 00:00'!
renderAllOn: aRenderer
	self renderHeadElementsOn: aRenderer.
	self renderHeaderOn: aRenderer.
	self renderContentOn: aRenderer.
	self renderFooterOn: aRenderer.! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:28'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:31'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			currentPage = index
				ifFalse: [html anchorWithAction: [self currentPage: index] text: index]
				ifTrue: [html bold: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'initialization' stamp: 'ab 5/25/2003 23:09'!
initialize
	batchSize _ 10.
	currentPage _ 1.! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize _ aNumber! !

!WABatchedList methodsFor: 'actions' stamp: 'ab 5/25/2003 23:06'!
nextPage
	self isOnLastPage ifFalse: [currentPage _ currentPage + 1]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'testing' stamp: 'ab 5/25/2003 23:06'!
isOnFirstPage
	^ currentPage = 1! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:17'!
endIndex
	^ currentPage * batchSize min: items size! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items _ aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:05'!
batch
	^ items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:28'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WABatchedList methodsFor: 'testing' stamp: 'ab 5/25/2003 23:06'!
isOnLastPage
	^ currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/29/2003 16:39'!
maxPages
	^ (items size / batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'ab 5/25/2003 23:06'!
previousPage
	self isOnFirstPage ifFalse: [currentPage _ currentPage - 1]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage _ aNumber! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:26'!
renderContentOn: html
	self maxPages > 0 ifTrue: [
		html divNamed: 'batch' with: [
			self renderPreviousOn: html.
			self renderPagesOn: html. 
			self renderNextOn: html ] ]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:09'!
startIndex
	^ (currentPage - 1) * batchSize + 1! !

WAComponent subclass: #WAClosureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 15:59'!
go
	|i|
	i _ 1.
	#(a b c) do: [:each | self inform: each asString, ' ', i asString. i _ i + 1]! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 16:00'!
ensure
	[self go] ensure: [self inform: 'ensure']! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 16:01'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'.
	html space.
	html anchorWithAction: [self ensure] text: 'go with ensure'.! !

WAComponent subclass: #WATrail
	instanceVariableNames: 'root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WATrail methodsFor: 'as yet unclassified' stamp: 'avi 9/17/2003 11:36'!
renderContentOn: html
	| list |
	list _ self controllersAndNames.
	list isEmpty ifTrue: [^ self].
	
	list do:
		[:assoc |
		assoc key = root activeController
			ifTrue: [html text: assoc value]
			ifFalse: [html anchorWithAction: [self backtrackTo: assoc key] text: assoc value].
		assoc = list last ifFalse: [html text: ' >> ']]! !

!WATrail class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root _ anObject! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:56'!
backtrackTo: aController
	aController clearDelegate! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:55'!
controllersAndNames
	| list object |
	list _ OrderedCollection new.
	object _ root.
	[object isNil] whileFalse:
		[(object respondsTo: #trailName)
			ifTrue: [list add: object -> object trailName].
		 object _ object delegate].
	^ list! !

WAComponent subclass: #WADialog
	instanceVariableNames: 'actions message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WADialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:08'!
renderContentOn: html
	html heading: message level: 3.
	html form: [
		actions do:
			[:assoc |
			html submitButtonWithAction: [self answer: assoc value value] text: assoc key]]! !

WADialog subclass: #WARadioDialog
	instanceVariableNames: 'label selection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WARadioDialog methodsFor: 'accessing' stamp: 'JF 6/23/2003 15:23'!
label: aString
	label _ aString! !

!WARadioDialog methodsFor: 'rendering' stamp: 'JF 9/15/2003 16:41'!
renderContentOn: html
	| group |
	html heading: message level: 3.
	
	group _ html radioGroup.
	
	html form: [
		actions do:
			[:assoc |
			html
				radioButtonInGroup: group
				selected: (selection contents = assoc value)
				callback:
					[:v |
					selection contents: assoc value.
					self answer: assoc value].
			html escapeText: assoc key.
			html break].
		
		html submitButtonWithText: label]! !

!WARadioDialog methodsFor: 'accessing' stamp: 'JF 6/23/2003 15:22'!
label
	^ label ifNil: [label _ 'OK']! !

!WARadioDialog class methodsFor: 'as yet unclassified' stamp: 'JF 6/23/2003 16:23'!
selectFrom: aCollection message: messageString label: labelString
	^ self new initializeWithActions: aCollection message: messageString label: labelString! !

!WARadioDialog methodsFor: 'accessing' stamp: 'JF 9/15/2003 16:16'!
select: anObject
	selection contents: anObject! !

!WARadioDialog methodsFor: 'accessing' stamp: 'JF 9/15/2003 16:15'!
selection: aStateHolder
	selection _ aStateHolder! !

!WARadioDialog methodsFor: 'initializing' stamp: 'JF 9/15/2003 16:13'!
initializeWithActions: aCollection message: messageString label: labelString
	message _ messageString.
	label _ labelString.
	selection _ WAStateHolder new.
	
	aCollection do:
		[:each | self on: each key answer: each value]! !

!WADialog class methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 17:57'!
confirmation: aString
	^ self new
			message: aString;
			on: 'Yes' answer: [true];
			on: 'No' answer: [false]! !

!WADialog methodsFor: 'as yet unclassified' stamp: 'ab 7/16/2002 11:29'!
message: aString
	message _ aString! !

!WADialog class methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 19:42'!
message: aString
	^ self new
		message: aString;
		on: 'OK' answer: [true]! !

!WADialog methodsFor: 'as yet unclassified' stamp: 'ab 7/16/2002 11:29'!
initialize
	message _ 'Hello'.
	actions _ OrderedCollection new.! !

!WADialog class methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:32'!
exampleMessage
	^ self message: 'Hello World'! !

!WADialog class methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:32'!
exampleConfirmation
	^ self confirmation: 'Tea?'! !

!WADialog methodsFor: 'as yet unclassified' stamp: 'ab 7/21/2002 15:55'!
on: aString answer: aBlock
	actions add: aString -> aBlock ! !

WAComponent subclass: #WAMessageFrame
	instanceVariableNames: 'message contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAMessageFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 18:01'!
contents: aController
	contents _ aController.
	contents onAnswer: [:v | self answer: v].! !

!WAMessageFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 17:59'!
message: aString
	message _ aString! !

!WAMessageFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 18:23'!
renderContentOn: html
	html cssClass: 'dialog-message'; heading: message level: 3.
	html divClass: 'dialog-contents' with: contents.! !

WAComponent subclass: #WAPrettyPrinter
	instanceVariableNames: 'root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAPrettyPrinter methodsFor: 'as yet unclassified' stamp: 'ab 6/3/2003 00:17'!
root: aComponent
	root _ aComponent! !

!WAPrettyPrinter methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:38'!
renderContentOn: html
	| doc context |
	doc _ WAHtmlResponse new.
	context _ WARenderingContext new
					actionUrl: 'action';
					callbacks: WACallbackStore new;
					document: doc.
	root renderWithContext: context.

	html divClass: 'html-source' with: [doc renderOn: html]! !

!WAPrettyPrinter class methodsFor: 'as yet unclassified' stamp: 'ab 6/3/2003 00:20'!
on: aComponent
	^ self new root: aComponent! !

!WAPrettyPrinter methodsFor: 'as yet unclassified' stamp: 'cwp 6/17/2003 20:11'!
style
	^'
.html-source {
	font-family: courier, serif;
	font-size: 9pt;
}

.tag-known {
	color: purple;
	font-weight: bold;
}

.attribute-known {
	font-weight: bold;
}

.attribute-value {
	color: blue;
}

.template {
	color: blue;
	font-weight: bold;
}

'! !

WAComponent subclass: #WADateRangeSelector
	instanceVariableNames: 'startDate endDate '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
addDays: aNumber
	self dateRangeIsValid ifTrue:
		[startDate date: (startDate date addDays: aNumber).
		endDate date: (endDate date addDays: aNumber).
		self changeDates]
			! !

!WADateRangeSelector class methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
example
	^ self new! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
nextDates
	self addDays: self dateRangeSize! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
endDate
	^ endDate date! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
previousDates
	self addDays: self dateRangeSize * -1! !

!WADateRangeSelector methodsFor: 'rendering' stamp: 'ab 5/25/2003 16:29'!
renderContentOn: html
	html form: [
		html table: [
			html tableRowWith: [html text: 'From:'] with: [html render: startDate].
			html tableRowWith: [html text: 'To:'] with: [html render: endDate].
			html tableRowWith: [] with:
				[html submitButtonWithAction: [self previousDates] text: 'Previous'.
				html submitButtonWithAction: [self nextDates] text: 'Next'.
				html space.
				html submitButtonWithAction: [self changeDates] text: 'Go'.
					]
		].
		self dateRangeIsValid ifFalse: [html paragraph: 'Invalid Date Range'].
	]! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 6/15/2003 12:45'!
changeDates
	self dateRangeIsValid ifTrue: [self changed]! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
dateRangeSize
	^ self dateRangeIsValid
		ifTrue: [self endDate subtractDate: self startDate]
		ifFalse: [0]! !

!WADateRangeSelector methodsFor: 'initialization' stamp: 'ab 5/25/2003 16:29'!
initialize

	startDate _ WADateSelector new date: Date today.
	endDate _ WADateSelector new date: (Date today addDays: 10)! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
startDate
	^ startDate date! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:29'!
startDate: aDate
	startDate date: aDate! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:30'!
endDate: aDate
	endDate date: aDate! !

!WADateRangeSelector class methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:26'!
initialize
	self registerAsApplication: 'rates'! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 7/10/2003 11:32'!
dateRangeIsValid
	^ (startDate dateIsValid
		and: [endDate dateIsValid])
		and: [startDate date <= endDate date]! !

WAComponent subclass: #WAScreenshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAScreenshot class methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:11'!
initialize
	self registerAsApplication: 'screenshot' sessionClass: WAAuthenticatedSession ! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'ab 10/2/2002 00:44'!
click: aPoint
	|evt|
	evt _ Sensor createMouseEvent.
	evt at: 3 put: aPoint x.
	evt at: 4 put: aPoint y.
	evt at: 5 put: 4.
	Sensor processEvent: evt.	
	evt at: 5 put: 0.
	Sensor processEvent: evt.	! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:39'!
renderContentOn: html
	html imageMapWithAction: [:pt | self click: pt] form: Display copy
	! !

!WAController methodsFor: 'delegation' stamp: 'ab 2/14/2003 02:30'!
delegate: aController
	delegate ifNil: [delegate _ WAStateHolder new].
	delegate contents: aController! !

!WAController methodsFor: 'call/answer' stamp: 'ab 6/24/2003 16:10'!
willAnswer
	^ true! !

!WAController methodsFor: 'convenience' stamp: 'ab 7/11/2003 18:10'!
request: requestString label: labelString default: initialString
	^ self call:
		((WAInputDialog new
			label: labelString;
			default: initialString)
				withMessage: requestString)! !

!WAController methodsFor: 'initialization' stamp: 'ab 6/24/2003 16:11'!
initializeController
	self willCall ifTrue: [delegate _ WAStateHolder new].
	self initialize.! !

!WAController methodsFor: 'convenience' stamp: 'JF 6/4/2003 12:14'!
request: aString default: initialString
	^ self request: aString label: nil default: initialString! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 18:11'!
withMessage: aString
	^ self new withMessage: aString! !

!WAController methodsFor: 'convenience' stamp: 'JF 6/4/2003 12:23'!
request: requestString label: labelString
	^ self request: requestString label: labelString default: ''! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 14:08'!
applicationWithPath: aString sessionClass: aClass
	^ (WAApplication path: aString)
		sessionClass: aClass;
		preferenceAt: #entryPoint put: self;
		yourself! !

!WAController methodsFor: 'call/answer' stamp: 'ab 2/14/2003 02:48'!
call: aComponent
	^ self delegateTo: aComponent during: [aComponent call]! !

!WAController methodsFor: 'call/answer' stamp: 'ab 2/13/2003 01:10'!
answer
	self answer: self! !

!WAController methodsFor: 'delegation' stamp: 'ab 2/15/2003 15:50'!
clearDelegate
	self delegate: nil! !

!WAController methodsFor: 'delegation' stamp: 'ab 2/14/2003 02:31'!
delegateTo: aController during: aBlock
	|value saved|
	saved _ self delegate.
	self delegate: aController.
	value _ aBlock value.
	self delegate: saved.
	^ value! !

!WAController methodsFor: 'call/answer' stamp: 'ab 7/10/2003 11:43'!
call
	^ self willAnswer
		ifFalse: [WARenderNotification raiseSignal]
		ifTrue:
			[Continuation currentDo: 
				[:cc |
				continuation _ cc.
				WARenderNotification raiseSignal]]! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 00:04'!
registerAsApplication: appName sessionClass: sessionClass
	|app|
	app _ self applicationWithPath: appName sessionClass: sessionClass.
	WADispatcher default registerEntryPoint: app at: appName.
	^ app! !

!WAController methodsFor: 'rendering' stamp: 'ab 2/16/2003 23:57'!
renderOn: aRenderer
	"for compatibility"
	self renderActiveControllerWithContext: aRenderer context! !

!WAController methodsFor: 'initialization' stamp: 'ab 2/13/2003 01:10'!
initialize! !

!WAController methodsFor: 'rendering' stamp: 'ab 2/13/2003 01:30'!
renderWithContext: aContext! !

!WAController methodsFor: 'convenience' stamp: 'ab 7/11/2003 18:11'!
confirm: aString
	^ self call: (WAYesOrNoDialog withMessage: aString)! !

WAController subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tasks'!

WATask subclass: #WAPluggableTask
	instanceVariableNames: 'block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tasks'!

!WAPluggableTask methodsFor: 'initialization' stamp: 'jf 11/10/2003 16:31'!
initializeWithBlock: aBlock
	super initializeController.
	block _ aBlock! !

!WAPluggableTask methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:38'!
block: aBlock
	block _ aBlock! !

!WAPluggableTask methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:38'!
go
	^ block value: self! !

!WAPluggableTask class methodsFor: 'instance creation' stamp: 'jf 11/10/2003 16:18'!
withBlock: aBlock
	^ self basicNew initializeWithBlock: aBlock! !

WATask subclass: #WATool
	instanceVariableNames: 'root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

WATool subclass: #WAExplorerTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAExplorerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
linkText
	^ 'Explore'! !

!WAExplorerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:53'!
title
	^ 'Component Explorer'! !

!WAExplorerTool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:44'!
go
	self call: (WAExplorer on: root)! !

!WATool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:42'!
root: aController
	root _ aController! !

!WATool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:43'!
linkText
	^ self name! !

WATool subclass: #WAMemoryUseTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
title
	^ 'Memory Use'! !

!WAMemoryUseTool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:44'!
go
	self call: (WAMemoryUse new root: self session)! !

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
linkText
	^ 'Memory Use'! !

WATool subclass: #WAProfilerTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAProfilerTool methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
go
	self call: (WAProfiler new child: root)! !

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
linkText
	^ 'Profile'! !

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
title
	^ 'Profiler'! !

WATool subclass: #WABrowserTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WABrowserTool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:45'!
go
	self call: (WABrowser fullOnClass: root activeController class)! !

!WABrowserTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
title
	^ 'System Browser'! !

!WABrowserTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
linkText
	^ 'Browse'! !

!WATool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:43'!
title
	^ self name! !

WATask subclass: #WAOnceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAOnceTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:33'!
go
	self inform: 'ready'.
	self session once: [1 to: 3 do: [:i | self inform: i asString]].
	self inform: 'done'.! !

WATask subclass: #WAStoreSearchTask
	instanceVariableNames: 'search '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreSearchTask methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 12:24'!
search: aString
	search _ aString! !

!WAStoreSearchTask methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 15:56'!
manyResults: aCollection
	self call: (WAStoreItemList new items: aCollection)! !

!WAStoreSearchTask methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:25'!
go
	|results |
	results _ WAStoreInventory default findItem: search.
	results size = 0
		ifTrue: [self noResults]
		ifFalse:
			[results size = 1
				ifTrue: [self oneResult: results first]
				ifFalse: [self manyResults: results]]! !

!WAStoreSearchTask methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 15:56'!
oneResult: anItem
	self call: (WAStoreItemView new item: anItem)! !

!WAStoreSearchTask methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 15:55'!
noResults
	self inform: 'Sorry, no results were found matching ', search printString! !

WATask subclass: #WATransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WATransactionTest methodsFor: 'as yet unclassified' stamp: 'ab 2/13/2003 16:51'!
go
	self inform: 'Before parent txn'.
	self session isolate: 
			[self inform: 'Inside parent txn'.
			self session isolate: [self inform: 'Inside child txn'].
			self inform: 'Outside child txn'].
	self inform: 'Outside parent txn'! !

!WATask methodsFor: 'as yet unclassified' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

WATask subclass: #WAExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAExceptionTest methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:14'!
go
	[(self confirm: 'Raise an exception?')
		ifTrue: [self error: 'foo']]
			on: Error
			do: [:e | self inform: 'Caught: ', e asString]! !

!WATask methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 19:34'!
renderWithContext: aContext
	|key|
	key _ aContext callbacks registerActionCallback: [self answer: self go].
	WASimulatedRequestNotification new
		request: (WARequest
					method: 'GET'
					url: aContext actionUrl
					headers: Dictionary new
					fields: (Dictionary with: key -> '')
					cookies: Dictionary new);
		raiseSignal! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 14:08'!
applicationWithPath: aString
	^ self applicationWithPath: aString sessionClass: self defaultSessionClass! !

!WAController methodsFor: 'delegation' stamp: 'ab 2/15/2003 15:51'!
activeController
	^ self delegate
		ifNil: [self]
		ifNotNil: [self delegate activeController]! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 3/28/2003 16:19'!
new
	^ super new initializeController! !

!WAController methodsFor: 'delegation' stamp: 'ab 6/24/2003 16:11'!
delegate
	^ self willCall ifTrue: [delegate contents] ! !

!WAController methodsFor: 'call/answer' stamp: 'ab 2/13/2003 01:10'!
answer: anObject
	continuation ifNotNil: [continuation value: anObject]! !

!WAController methodsFor: 'call/answer' stamp: 'ab 5/25/2003 17:29'!
onAnswer: aBlock
	continuation _ aBlock! !

!WAController methodsFor: 'convenience' stamp: 'ab 7/11/2003 18:08'!
withMessage: aString
	^ WAMessageFrame new
		contents: self;
		message: aString;
		yourself! !

!WAController methodsFor: 'convenience' stamp: 'ab 2/18/2003 20:30'!
request: aString
	^ self request: aString default: ''! !

Object subclass: #WAPreference
	instanceVariableNames: 'key value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Preferences'!

!WAPreference class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:54'!
key: aSymbol value: anObject
	^ self new
		key: aSymbol;
		value: anObject! !

WAPreference subclass: #WAListPreference
	instanceVariableNames: 'options '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Preferences'!

!WAListPreference class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:54'!
key: aSymbol value: anObject options: aCollection
	^ (self key: aSymbol value: anObject) options: aCollection! !

!WAListPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:50'!
options: aCollection
	options _ aCollection! !

!WAListPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:51'!
renderOn: html
	html selectFromList: options selected: value callback: [:v | value _ v]! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:49'!
renderOn: html
	html render: value! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:54'!
key
	^ key! !

WAPreference subclass: #WABooleanPreference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Preferences'!

!WABooleanPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:50'!
renderOn: html
	html booleanMenuOn: #value of: self! !

WAPreference subclass: #WANumberPreference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Preferences'!

!WANumberPreference methodsFor: 'as yet unclassified' stamp: 'JF 6/10/2003 16:32'!
renderOn: html
	html attributes size: (value asString size max: 10).
	html textInputWithValue: (value asString) callback: [:v | self value: v asNumber]! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'JF 6/10/2003 16:31'!
value: anObject
	value _ anObject! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:54'!
key: aSymbol
	key _ aSymbol! !

WAPreference subclass: #WAStringPreference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Preferences'!

!WAStringPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:49'!
renderOn: html
	html attributes size: (value size max: 10).
	html textInputOn: #value of: self.! !

!WAPreference methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:48'!
value
	^ value! !

Object subclass: #WAWikiWiki
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Wiki'!

!WAWikiWiki methodsFor: 'as yet unclassified' stamp: 'ab 11/27/2002 00:09'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: ['Describe ', aMessage selector printString, ' here.']
		ifFalse: [super doesNotUnderstand: aMessage]! !

!WAWikiWiki methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 01:49'!
test1
"test1"^ 
'asdasdasdasd!!'! !

!WAWikiWiki methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 18:32'!
start
"start"^ 
'!!Hello, world...
This is a bare-bones wiki example in Seaside, stealing some code from Gran''s Wiki Formatter.

It stores pages as methods of *WAWikiWiki*.
- *Test1*            '! !

!WAWikiWiki methodsFor: 'as yet unclassified' stamp: 'ab 3/17/2003 13:43'!
wAWikiWiki
"WAWikiWiki"^ 
'Describe #wAWikiWiki here.  '! !

Object subclass: #WAStateHolder
	instanceVariableNames: 'contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-State'!

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:05'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	contents printOn: aStream.
	aStream nextPut: $).! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:04'!
contents
	^ contents! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:04'!
contents: anObject
	contents _ anObject! !

!WAStateHolder class methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:48'!
new
	|inst|
	inst _ super new.
	WASession currentSession registerObjectForBacktracking: inst.
	^ inst! !

Object subclass: #WAResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

WAResponse subclass: #WANotFoundResponse
	instanceVariableNames: 'location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WANotFoundResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:13'!
location: aString
	^ self new location: aString! !

!WANotFoundResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:14'!
status
	^ '404'! !

!WANotFoundResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:13'!
location: aString
	location _ aString! !

!WANotFoundResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:31'!
contentString
	^ '<h1> Error: "', location, '" not found. </h1>'.! !

WAResponse subclass: #WARedirectResponse
	instanceVariableNames: 'location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WARedirectResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:45'!
location: aString
	location _ aString
! !

!WARedirectResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 16:40'!
status
	^ '302'! !

!WARedirectResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:45'!
headers
	^ Array with: 'Location' -> location! !

!WARedirectResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 16:40'!
location: aString
	^ self new location: aString! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 16:40'!
status
	^ '200'! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 14:55'!
new
	^ super new initialize! !

WAResponse subclass: #WAGenericResponse
	instanceVariableNames: 'contentType headers cookies status stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/3/2002 21:45'!
status: statusString
	status _ statusString! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
cookieAt: key put: value
	cookies at: key put: value! !

!WAGenericResponse class methodsFor: 'as yet unclassified' stamp: 'ab 12/30/2002 17:32'!
new
	^ super new initialize! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
headerAt: key put: value
	headers at: key put: value! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/3/2002 21:58'!
contentType: mimeTypeString
	contentType _ mimeTypeString! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
cookies
	^ cookies! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
headers
	^ headers! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAGenericResponse class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 22:49'!
document: anObject mimeType: mimeType
	|doc|
	doc _ anObject asMIMEDocument.
	^ self new
		contentType: (mimeType ifNil: [doc contentType]);
		headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
		nextPutAll: doc content! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 5/28/2003 22:54'!
initialize
	headers _ Dictionary new.
	cookies _ Dictionary new.
	stream _ String new writeStream.
	status _ '200'.
	contentType _ 'text/html'.
! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:38'!
contents
	^ stream contents readStream! !

!WAResponse methodsFor: 'http' stamp: 'ab 5/28/2003 22:47'!
initialize
	! !

WAResponse subclass: #WABasicAuthResponse
	instanceVariableNames: 'realm '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WABasicAuthResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 16:34'!
status
	^ '401'! !

!WABasicAuthResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:44'!
realm: aString
	realm _ aString.
! !

!WABasicAuthResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:45'!
headers
	^ Array with: 'WWW-Authenticate' -> ('Basic realm="',realm,'"')! !

!WABasicAuthResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:31'!
contentString
	^ '<h1>Authentication Failed</h1>'! !

!WABasicAuthResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 16:34'!
realm: aString
	^ self new realm: aString! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
headers
	^ #()! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:49'!
contentString
	^ self printString! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:33'!
contents
	^ self contentString readStream! !

!WAResponse methodsFor: 'optimizing' stamp: 'JF 6/17/2003 17:30'!
release
	1 to: self class instSize do: [:i | self instVarAt: i put: nil]! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 16:40'!
contentType
	^ 'text/html'! !

WAResponse subclass: #WAHtmlResponse
	instanceVariableNames: 'head stack body '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Document'!

!WAHtmlResponse methodsFor: 'accessing' stamp: 'ab 1/11/2003 12:29'!
body
	^ body! !

!WAHtmlResponse methodsFor: 'accessing' stamp: 'ab 1/11/2003 12:29'!
head
	^ head! !

!WAHtmlResponse methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:57'!
pushElement: anObject
	self addElement: anObject.
	stack add: anObject.! !

!WAHtmlResponse methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:58'!
withElement: anElement do: aBlock
	self pushElement: anElement.
	aBlock value.
	self popElement.! !

!WAHtmlResponse methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:46'!
popElement
	stack removeLast! !

!WAHtmlResponse class methodsFor: 'as yet unclassified' stamp: 'ab 1/11/2003 12:27'!
new
	^ super new initialize! !

!WAHtmlResponse methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:46'!
addElement: anObject
	stack last add: anObject! !

!WAHtmlResponse methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 16:44'!
printHtmlOn: aStream
	aStream nextPutAll: '<html>'.
	head printHtmlOn: aStream.
	body printHtmlOn: aStream.
	aStream nextPutAll: '</html>'.! !

!WAHtmlResponse methodsFor: 'accessing' stamp: 'ab 6/15/2003 16:44'!
initialize
	head _ WAHtmlElement named: 'head'.
	body _ WAHtmlElement named: 'body'.
	stack _ OrderedCollection with: body! !

!WAHtmlResponse methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:52'!
renderOn: html
	| root |
	root _ WAHtmlElement named: 'html'.
	
	root add: head.
	root add: body.
	
	root renderOn: html indentLevel: 0! !

!WAHtmlResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 22:03'!
contents
	|stream|
	stream _ ReadWriteStream on: String new.
	self printHtmlOn: stream.
	^ stream reset! !

WAResponse subclass: #WARefreshResponse
	instanceVariableNames: 'location delay message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WARefreshResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:17'!
message: aString
	message _ aString! !

!WARefreshResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:33'!
contentString
	^ '<html>
			<head>
			<meta http-equiv="refresh" content="',delay asString,';URL=',location,'">
			<title>',message,'</title>
			</head>
			<body>
			<h1>',message,'</h1>
			You are being redirected to <a href="',location,'">',location,'</a>
			</body>
		</html>'
	! !

!WARefreshResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:16'!
message: aString location: urlString delay: aNumber
	^ self new
		message: aString;
		location: urlString;
		delay: aNumber! !

!WARefreshResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:17'!
delay: aNumber
	delay _ aNumber! !

!WARefreshResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:17'!
location: aString
	location _ aString! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
cookies
	^ #()! !

Object subclass: #WAStoreInventory
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

WAStoreInventory class
	instanceVariableNames: 'default '!

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:20'!
default
	^ default ifNil: [default _ self new initialize]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
allItems
	^ items! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
findItem: searchString
	^ items select: [:ea | ea matches: searchString]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
itemSpecs
"adapted from http://www.thaddeus.com/ftp/database/sushi.zip"
	^ #(
#('Akami Maguro' 'Red Tuna' 'The lean meat near the spine of the tuna fish.  It comes in various shades of red--with the lighter, shinier varieties being the best.  For dieters, however, the redder the better.  Easy on the palatte.  The least expensive of the three types of maguro.' 150)
#('Chutoro Maguro' 'Fatty Tuna' 'The moderately fatty part of the tuna belly.  It''s pink, but not the faint pink of ohtoro.  Soft, butter-like texture.  Moderately expensive.' 275)
#('Geso Ika' 'Cuttlefish Tentacles' 'White in color, geso is boiled and brushed with thick teriyaki sauce before serving as sushi.  Its texture is chewy, and its mild flavor is complemented by the sweet-salty teriyaki.' 200)
#('Himo Akagai' 'Ark Shell Filaments' 'This is the thread-like edges which connect the flesh to the shell.  A delicious, soft texture and mild taste.' 200)
#('Hotategai' 'Scallop' 'The part of the scallop that is eaten is the edible adductor muscle that opens the animal''s shell.  It''s pale beige-yellow in color with a brown, crusty edging.  The taste is delicate, and melts in your mouth. ' 250)
#('Iwashi' 'Sardine' 'Shiny, slippery, and ''fishy,'' the taste of sardine sushi is slightly oily.  Sardine must be eaten shortly after it has been caught if it''s to be used in Sushi.  Often eaten with soy sauce mixed with ginger and onion.' 175)
#('Kazunoko' 'Herring Roe' 'An expensive delicacy which is also known as ''yellow diamonds'' (because of the color and expense).  Revered in Japan, it''s usually eaten on special occasions.  An acquired taste for Westerners.' 475)
#('Kisu' 'Sillago' 'A fresh Sillago has bright-gold skin. The taste is mild and delicate.' 225)
#('Ohtoro Maguro' 'Fattiest Tuna' 'Fattiest part of the fatty tuna belly.  It is light pink in color and melts in your mouth.  Mild with a rich texture.  This is the most expensive of the three types of Maguro sushi.' 325)
#('Shima-Aji' 'Yellow Jack' 'A slice of white silvery shima-aji eaten with beef-steak plant and fresh ginger is delicious.  The flavor is delicate and the texture of good, fresh yellow jack is smooth and slides down easily.' 180)
#('Aji' 'Horse Mackerel' 'This fish is pink-grey and shiny.  When it''s fresh, the flesh is almost transparent.  The texture is slippery and easy on the tongue--it should melt in your mouth.  Aji is often eaten with soy sauce containing onion, ginger and garlic.' 250)
#('Inarizushi' 'Stuffed Bean Curd Rolls' '' 200)
#('Kappa Maki' 'Cucumber Rolls' '' 150)
#('Sakura Denbu' 'Shredded Cod Fish' 'Seasoned shredded cod fish.' 200)
#('California Roll' '' 'Rice, cucumber, crab meat, & avacado.' 250)
#('Futo-Maki' 'Fat Rolls' 'Kampyo gourd, oboro or denbu pink powder, tamago omelet, and shiitake mushrooms. May also include bamboo shoots, cucumbers, cooked eel, cooked carrots, and cooked spinach or other greens.' 275)
#('Tekkamaki' 'Tuna Roll' 'Tuna wrapped in rice and nori.' 225)
#('Chakinzushi' 'Omelet-wrapped Sushi' 'Sushi rice in a thin omelet wrapper shaped and tied like a lady''s drawstring purse.  Sometimes a single pea or small shrimp decorates the ruffled part of the wrapper.' 300)
#('Shiro Maguro' 'Albacore Tuna' '' 300)
#('Hamachi' 'Yellowtail' '' 325)
#('Kohada' 'Gizzard Shad' 'This Japanese shad is a member of the herring family, and is a small silver-grey fish, with a black spotted back.  Marinated in vinegar and cross- hatched before serving.  The taste is strong, and a favorite for herring fans.' 275)
#('Katsuo' 'Bonito' '' 275)
#('Saba' 'Mackerel' '' 200)
#('Sake' 'Salmon' '' 250)
#('Tai' 'Red Snapper' '' 250)
#('Hirame' 'Flounder' 'Good hirame is a sushi gourmet''s delight.  Since it''s cut from such a small part of the fish, it''s scarce and expensive.  In appearance, it''s pale pink and smooth, with no markings.  The taste is delicate and buttery.' 350)
#('Suzuki' 'Sea Bass' '' 300)
#('Unagi' 'Freshwater Eel' '' 300)
#('Ika' 'Cuttlefish' 'When fresh, cuttlefish is almost transparent.  It''s butter-like and melts in your mouth.  The texture is sticky.  Cuttlefish is smoky white and glistens. Also popular grilled and mixed with ginger soy sauce.  Also good with lemon for Western palettes.' 325)
#('Awabi' 'Abalone' 'Abalone or ''sea snail'' is another sushi favorite.  The color ranges from beige-grey to pinkish yellow.  Fresh abalone is not too rubbery, and is very subtle in flavor.' 300)
#('Mirugai' 'Horse Clam' 'Also known as Geoduck.  This is a large, hard-shelled clam which is yellowish-white in color.  It has a slight ''shellfish'' taste and an elastic type texture. The part used in sushi is the long muscular siphon which projects from the shell.' 350)
#('Akagai' 'Ark Shell Clam' 'The softest texture of any shellfish. Akagai has an attractive pink-orange color.  The taste is delicate and slightly sweet.' 300)
#('Kobashira' 'Trough Shell (Small) Scallop' 'The edible adductor muscle that opens the shell of the aoyagi.  More prized than the aoyagi itself.' 500)
#('Kani' 'Crab' '' 250)
#('Ebi' 'Cooked Prawn' '' 225)
#('Ikura' 'Salmon Roe' 'Appealing to the eye with its bright red color.  Very appetizing with a delicate taste.' 325)
#('Tobiko ' 'Flying-Fish Roe' '' 350)
#('Masago ' 'Capelin Roe' '' 350)
#('Anago' 'Conger Eel' 'Anago is one of the few pre-cooked sushi.  It is grilled and basted with a thick teriyaki sauce.  The soft, slighty warm eel, the sweet soy sauce, and the vinegared rice make a particularly delicious sushi.' 300)
#('Uni' 'Sea Urchin Roe' 'A prized delicacy with its oily, rich texture.  Mustard color, paste-like topping is held in place by a band of nori seaweed.' 400)
) asSortedCollection: [:a :b | a first <= b first]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
initialize
	items _ OrderedCollection new.
	self itemSpecs do:
		[:row |
		items add: (self itemFromSpec: row)]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
itemFromSpec: anArray
	^ WAStoreItem new
		title: anArray first;
		subtitle: anArray second;
		description: anArray third;
		price: anArray fourth! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|members|
	members _ self class allInstVarNames
					collect: [:ivar | ivar -> (self instVarNamed: ivar)].
						
	self class isVariable ifTrue:
		[members _ members, ((1 to: self size) collect: [:i | i -> (self at: i)])].
	^ members! !

Object subclass: #VWSqueakExtensionsInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Info'!

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:29'!
includesClass: aClass
	^ false! !

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:26'!
externalName
	^ 'Seaside-Squeak'! !

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:27'!
classes
	^ #()! !

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:30'!
methodSpecs
	^ #((String beginsWith:)
		(String findTokens:)
		(SequenceableCollection allButFirst:))! !

!VWSqueakExtensionsInfo class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:28'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self new on:
		(FileStream forceNewFileNamed: 'SeasideSqueakExtensions.st')! !

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:27'!
methods
	^ self methodSpecs collect:
		[:pair |
		MethodReference new
			setClassSymbol: pair first
			classIsMeta: false
			methodSymbol: pair second
			stringVersion: '']! !

Object subclass: #WACallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Callbacks'!

!WACallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
evaluateWithObject: anObject store: aCallbackStore
	self subclassResponsibility ! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
isValueCallback
	^ false! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Callbacks'!

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:04'!
evaluateWithObject: anObject store: aCallbackStore
	self value: anObject! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 23:20'!
block: aBlock
	block _ aBlock fixTemps! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:04'!
value: anObject
	block numArgs = 1
		ifTrue: [block value: anObject]
		ifFalse: [block value]! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
isValueCallback
	^ true! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:02'!
isDispatchCallback
	^ false! !

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Callbacks'!

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:46'!
trigger
	block value! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
isActionCallback
	^ true! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:01'!
evaluateWithObject: anObject store: aCallbackStore
	aCallbackStore action: self! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 23:19'!
block: aBlock
	block _ aBlock fixTemps! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:02'!
isActionCallback
	^ false! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Callbacks'!

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
isDispatchCallback
	^ true! !

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:49'!
evaluateWithObject: anObject store: aCallbackStore
	aCallbackStore evaluateCallbackAt: anObject with: nil! !

Object subclass: #WAHtmlAttributes
	instanceVariableNames: 'associations '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Document'!

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 15:04'!
cssClassForAttribute: aString
	^ (self isKnownAttribute: aString) ifTrue: ['attribute-known'] ifFalse: ['attribute-unknown']! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:58'!
isKnownAttribute: aString
	^ self knownAttributes includes: aString asLowercase! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'ab 5/12/2003 22:08'!
alignCenter
	self at: 'align' put: 'center'! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'ab 5/12/2003 11:21'!
printHtmlOn: aStream
	associations ifNotNil:
		[associations do:
			[:assoc |
			self printAttribute: assoc on: aStream]].! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 15:06'!
renderAttribute: assoc on: html
	| attr value |
	attr _ assoc key asLowercase.
	value _ assoc value.
	
	value = false ifFalse:
		[html space.
		html spanClass: (self cssClassForAttribute: attr) with:
			[html encodeText: attr].
		html encodeText: '='.
		html spanClass: 'attribute-value' with:
			[html encodeText: '"'.
			value = true
				ifFalse: [html encodeText: value asString]
				ifTrue: [html encodeText: attr].
			html encodeText: '"']]! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:57'!
knownAttributes
	^ #(abbr
accept-charset
accept
accesskey
action
align
alink
alt
archive
axis
background
bgcolor
bgproperties
border
cellpadding
cellspacing
char
charoff
charset
checked
cite
class
classid
clear
code
codebase
codetype
color
cols
colspan
compact
content
coords
data
datetime
declare
defer
dir
direction
disabled
encoding
enctype
face
for
frame
frameborder
framespacing
gutter
headers
height
href
hreflang
hspace
http-equiv
id
ismap
label
lang
leftmargin
link
longdesc
loop
lowsrc
marginheight
marginwidth
maxlength
media
method
methods
multiple
name
nohref
noresize
noshade
nowrap
object
onabort
onblur
onchange
onclick
ondblclick
onerror
onfocus
onkeydown
onkeypress
onkeyup
onload
onmousedown
onmousemove
onmouseout
onmouseover
onmouseup
onreset
onselect
onsubmit
onunload
prompt
PUBLIC
readonly
rel
rev
rows
rowspan
rules
scheme
scope
scrolling
selected
shape
size
span
src
standby
style
summary
tabindex
target
text
title
type
urn
usemap
valign
value
valuetype
version
vlink
vspace
width
wrap
xml:lang
xmlns)! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 13:06'!
renderOn: html
	associations ifNotNil:
		[associations do:
			[:assoc |
			self renderAttribute: assoc on: html]].! !

!WAHtmlAttributes methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:42'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self at: aMessage selector put: true].
	argCount = 1 ifTrue: [^ self at: aMessage selector allButLast put: aMessage argument].
	^ super doesNotUnderstand: aMessage! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ab 5/12/2003 11:14'!
at: keyString put: valueString
	associations ifNil: [associations _ OrderedCollection new].
	associations add: keyString -> valueString.! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'ab 5/12/2003 11:21'!
printAttribute: assoc on: aStream
	assoc value = false ifFalse:
		[aStream nextPut: $ .
		aStream nextPutAll: assoc key asLowercase.
		aStream nextPutAll: '="'.
		assoc value = true
			ifFalse: [aStream nextPutAll: assoc value asString]
			ifTrue: [aStream nextPutAll: assoc key asLowercase].
		aStream nextPut: $"]! !

Object subclass: #WAStoreCart
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
remove: anObject
	items remove: anObject ifAbsent: []! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:21'!
items
	^ items! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:21'!
isEmpty
	^ items notNil and: [items isEmpty not]! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:41'!
totalPrice
	^ items detectSum: [:ea | ea price]! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
countsAndItems
	^ items sortedCounts! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:36'!
add: anObject
	items ifNil: [items _ Bag new].
	items add: anObject! !

Object subclass: #Amb
	instanceVariableNames: 'failureContinuation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Backtracking'!

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:12'!
deny: aBoolean
	self assert: aBoolean not! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:15'!
fail
	^ failureContinuation value: nil! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo or: blockThree
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo with: blockThree)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:29'!
maybe
	^ self oneOf: (Array with: true with: false)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
allValues: aBlock
	|kPrev results|
	kPrev _ failureContinuation.
	results _ OrderedCollection new.
	(Continuation currentDo:
		[:kRetry |
		failureContinuation _ [:v | kRetry value: false].
		results add: aBlock value.
		kRetry value: true])
			ifTrue: [self fail].
	failureContinuation _ kPrev.
	^ results asArray	 ! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:09'!
oneOf: aCollection
	^ self valueOfOneOf: (aCollection collect: [:ea | [ea] fixTemps])! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
valueOfOneOf: blockCollection
	|kPrev|
	kPrev _ failureContinuation.
	^ Continuation currentDo:
		[:kEntry |
		blockCollection do:
			[:ea |
			Continuation currentDo:
				[:kNext |
				failureContinuation _
					[:v | failureContinuation _ kPrev. kNext value: v] fixTemps.
				kEntry value: ea value]].
		kPrev value: nil]
			 ! !

!Amb class methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 01:59'!
new
	^ super new initialize! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:00'!
initialize
	failureContinuation _ [self error: 'Amb tree exhausted'].! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:11'!
assert: aBoolean
	aBoolean ifFalse: [self fail]! !

Object subclass: #WAModLisp
	instanceVariableNames: 'listener '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Connections'!

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 15:01'!
readDataFrom: aSocket 
	| key info stream|
	info _ Dictionary new.
	stream _ SocketStream on: aSocket.
	[(key _ stream upTo: Character lf) = 'end']
		whileFalse: [
			stream next.
			info at: key asLowercase put: (stream upTo: Character lf).
			stream next].
	info at: 'content-length' ifPresent:
		[:cl | info at: 'content' put: (stream next: cl asNumber + 1)].
	^ info! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'ab 5/7/2002 11:08'!
serve: aSocket
	[self process: aSocket. aSocket closeAndDestroy] fork! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'ab 1/14/2003 01:49'!
process: aSocket
	| info query |	
	info _ self readDataFrom: aSocket.
	query _ self processQuery: info.
	self halt.! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'ab 1/14/2003 01:46'!
serveOn: port
	Socket initializeNetwork.
	listener ifNotNil: [listener stop].
	listener _ ConnectionHandler onPort: port handler: [:s | self serve: s] priority: Processor highIOPriority.
	listener start.! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 14:58'!
processQuery: infoDictionary 
	^ (infoDictionary at: 'method') = 'GET'
		ifTrue: [self decodeFields: ((infoDictionary at: 'url') copyAfter: $?)]
		ifFalse: [self processPost: infoDictionary]
! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2002 18:06'!
unEscape: aString 
	"Convert escape sequences to their proper characters."
	| rs c |
	rs _ ReadStream on: aString.
	^ String streamContents:
		[:ws |
			[rs atEnd]
				whileFalse:
				[c _ rs next.
				ws
				nextPut: (c = $+
						ifTrue: [$ ]
						ifFalse: [c = $%
								ifTrue: [(Number readFrom: (rs next: 2) asUppercase base: 16) asCharacter]
								ifFalse: [c]])]]! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 10/21/2001 07:42'!
decodeFields: aString 
	"Convert the form fields in aString to a query dictionary."
	| query dict i key value |
	query _ aString findTokens: '&'.
	dict _ Dictionary new.
	query
		do: [:tag | 
			i _ tag indexOf: $=.
			key _ tag copyFrom: 1 to: i - 1.
			value _ i < tag size
						ifTrue: [self
								unEscape: (tag copyFrom: i + 1 to: tag size)].
			(dict includesKey: key)
				ifTrue: [((dict at: key)
							isKindOf: String)
						ifTrue: [dict
								at: key
								put: (OrderedCollection
										with: (dict at: key))].
					(dict at: key)
						add: value]
				ifFalse: [dict at: key put: value]].
	^ dict! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 15:16'!
processMultipartFields: aString withSeparator: aSeparator
	^ self processMultipartFields:
		(aString findBetweenSubStrs: (Array with: aSeparator))! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 15:08'!
processMultipartFields: aString
	self halt.
	^ Dictionary new! !

!WAModLisp class methodsFor: 'as yet unclassified' stamp: 'AB 12/8/2001 00:22'!
start
	self startOn: 3000! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 15:14'!
processPost: infoDictionary 
	^ (infoDictionary at: 'content-type') = 'application/x-www-form-urlencoded'
		ifTrue: [self decodeFields: (infoDictionary at: 'content')]
		ifFalse: [self processMultipartFields: (infoDictionary at: 'content')
					  withSeparator: ((infoDictionary at: 'content-type') copyAfter: $=)]
! !

!WAModLisp class methodsFor: 'as yet unclassified' stamp: 'AB 12/14/2001 17:29'!
startOn: port
	instances ifNil: [instances _ Dictionary new].
	(instances at: port ifAbsentPut: [self new]) serveOn: port.! !

Object subclass: #Continuation
	instanceVariableNames: 'values '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Backtracking'!

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 23:29'!
initializeFromContext: aContext
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context size do: [:i | valueStream nextPut: (context at: i)].
		context _ context sender].
	values _ valueStream contents! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context _ aContext.
	[context notNil] whileTrue: [context _ context swapSender: nil]
! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!Continuation methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:17'!
restoreValues
	| valueStream context |
	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context size do: [:i | context at: i put: valueStream next]]! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields path headers cookies handlerKey actionKey method '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'private' stamp: 'ab 8/26/2003 19:34'!
setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	method _ methodString.
	url _ urlString.
	headers _ headDict.
	fields _ fieldDict.
	cookies _ cookieDict.
	self parseUrl.! !

!WARequest methodsFor: 'accessing' stamp: 'ab 11/12/2002 00:04'!
cookies
	^ cookies! !

!WARequest methodsFor: 'accessing' stamp: 'ab 2/11/2003 20:17'!
hasHandlerKey
	^ handlerKey isEmpty not! !

!WARequest methodsFor: 'accessing' stamp: 'ab 2/11/2003 20:42'!
path
	^ path! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
user
	^ self authorization ifNotNilDo: [:auth | auth copyUpTo: $:]! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
password
	^ self authorization ifNotNilDo: [:auth | auth copyAfter: $:]! !

!WARequest methodsFor: 'private' stamp: 'ab 1/13/2003 22:40'!
authorization
	^ (self headerAt: 'Authorization' ifAbsent: [self headerAt: 'authorization'])
		ifNotNilDo: [:auth | self decodeAuthorization: auth]! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'private' stamp: 'ab 7/11/2003 00:09'!
parseUrl
	|stream|
	
	stream _ url readStream.
	path _ stream upToAndSkipThroughAll: WARegistry handlerKeySeparator.
	handlerKey _ stream upTo: $/.
	actionKey _ stream upToEnd.
! !

!WARequest methodsFor: 'accessing' stamp: 'ab 2/11/2003 20:20'!
handlerKey
	^ handlerKey! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'ab 2/11/2003 20:20'!
actionKey
	^ actionKey! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 19:34'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	^ self new setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict! !

Object subclass: #WAKom
	instanceVariableNames: 'handler '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Connections'!

WAKom class
	instanceVariableNames: 'port service '!

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
stop
	self pause.
	port _ nil.
! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 9/16/2003 13:37'!
process: komRequest
	|request response komResponse|
	Transcript cr; show: komRequest rawUrl.
	self processMultipartFields: komRequest.
	
	request _ WARequest
					method: komRequest method
					url: komRequest url unescapePercents 
					headers: komRequest header
					fields: (komRequest method = 'POST'
									ifTrue: [komRequest postFields]
									ifFalse: [komRequest getFields])
					cookies: komRequest cookies.

	komRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (komRequest stream next: komRequest contentLength)].
	 
	response _ handler handleRequest: request.
	response ifNil: [^ ''].
	
	komResponse _ HttpResponse new.

	response cookies associationsDo:
		[:assoc | komResponse setCookieName: assoc key value: assoc value path: '/'].
		
	response headers associationsDo: [:assoc | komResponse fieldAt: assoc key put: assoc value].
	(HttpResponse classPool at: #StatusCodes) associationsDo:
		[:assoc |
		assoc value key = response status ifTrue: [komResponse status: assoc key]].
	komResponse contents: response contents.
	komResponse contentType: response contentType.

	"release the response as a memory optimization"
	response release.

	^ komResponse! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 13:44'!
default
	^ self handler: WADispatcher default! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 14:11'!
validateForStack: anArray! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
startOn: aPort
	self stop.
	port _ aPort.
	service _ self createService.
	service start.
! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setDebugMode
	service setDebugMode.! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:54'!
createService
	Smalltalk at: #HttpService ifPresent:
		[:hs |
		^ (hs on: port named: 'seaside') plug: self default].
	Smalltalk at: #ComancheNetService ifPresent:
		[:cns |
		^ (cns named: 'seaside' onPort: port) module: self default]! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:33'!
setDeploymentMode
	service setDeploymentMode.! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
pause
	service ifNotNil:
		[service unregister.
		service _ nil]! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 13:53'!
processHttp
	HttpResponse current: (self process: HttpRequest current).
	^ true! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 12:47'!
handler: aRequestHandler
	handler _ aRequestHandler! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:42'!
initialize
		Smalltalk addToStartUpList: self after: AutoStart.
		Smalltalk addToShutDownList: self! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 11:24'!
processHttpRequest: aRequest
	^ self process: aRequest! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:42'!
shutdown
	self pause! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 13:44'!
handler: aRequestHandler
	^ self new handler: aRequestHandler! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
processMultipartFields: aRequest
	aRequest multipartFormFieldsDo:
		[:chunk |
		chunk fileName isEmptyOrNil ifFalse:
			[|stream file|
			stream _ WriteStream on: String new.
			chunk saveToStream: stream.
			file _ WAFile new fileName: chunk fileName; contents: stream contents.
			aRequest postFields at: chunk fieldName put: file]].! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setVerboseMode
	service setVerboseMode.! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:00'!
entryPoint: aClass path: aString
	^ self handler: (aClass applicationWithPath: aString)! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 12:47'!
handler
	^ handler! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
startUp
	port ifNotNil: [self startOn: port]! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 21:50'!
new
	^ super new initialize! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
initialize
	formatBlock _ [:x | x asString].
	sortBlock _ [:a :b | a <= b].
	valueBlock _ [:row | nil].
	clickBlock _ nil.
	title _ 'Untitled'.
	hasTotal _ false.! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock _ aBlock! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock _ [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
hasTotal: aBoolean
	hasTotal _ aBoolean ! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs _ anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs _ assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title _ aString! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:08'!
canSort
	^ sortBlock notNil! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
valueBlock: aBlock
	valueBlock _ aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 11/12/2002 14:31'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock _ [:row | row perform: aSymbol]! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

Object subclass: #WAWarningPage
	instanceVariableNames: 'warning '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Utilities'!

!WAWarningPage methodsFor: 'as yet unclassified' stamp: 'ab 8/28/2003 20:38'!
session
	^ WASession currentSession! !

!WAWarningPage methodsFor: 'as yet unclassified' stamp: 'ab 8/28/2003 20:17'!
proceed
	warning resume! !

!WAWarningPage methodsFor: 'as yet unclassified' stamp: 'avi 8/30/2003 21:30'!
responseWithUrl: aString
	| response |
	response _ WAGenericResponse new.
	response
		nextPutAll: '<h3>Warning</h3>';
		nextPutAll: (warning messageText copyReplaceAll: String cr with: '<br>');
		nextPutAll: '<form action="', aString, '">';
		nextPutAll: '<input type="submit" name="action" value="Proceed">';
		nextPutAll: '</form>'.
	^ response! !

!WAWarningPage class methodsFor: 'as yet unclassified' stamp: 'ab 8/28/2003 20:11'!
warning: aWarning
	^ self new warning: aWarning! !

!WAWarningPage methodsFor: 'as yet unclassified' stamp: 'ab 8/28/2003 20:11'!
warning: aWarning
	warning _ aWarning! !

!WAWarningPage methodsFor: 'as yet unclassified' stamp: 'ab 8/28/2003 20:14'!
show
	| req |
	self session redirect.
	req _ self session respond: [:url | self responseWithUrl: url].
	self perform: (req at: 'action') asLowercase asSymbol.! !

Object subclass: #WAFile
	instanceVariableNames: 'contents fileName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Utilities'!

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
fileName
	"compensate for windows explorer behavior"
	^ ('#:\*' match: fileName)
		ifTrue: [fileName copyAfterLast: $\]
		ifFalse: [fileName]! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
contents
	^ contents! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
contents: aStream
	contents _ aStream! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
fileName: aString
	fileName _ aString! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'timeout process semaphore '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Utilities'!

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 9/26/2002 19:54'!
timeoutSeconds: aNumber
	timeout _ aNumber! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 9/27/2002 00:58'!
initialize
	timeout _ 5.
	semaphore _ Semaphore forMutualExclusion.
	process _ [] newProcess.! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 14:50'!
timeout
	^ timeout! !

!WAProcessMonitor class methodsFor: 'as yet unclassified' stamp: 'ab 9/26/2002 19:53'!
new
	^ super new initialize! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 3/28/2003 17:40'!
critical: aBlock
	|value|
	semaphore waitTimeoutSeconds: self timeout.
	process install: [
		value _ aBlock value.
		semaphore signal.
		] newProcess suspendedContext.
	process resume.
	semaphore wait.
	process terminate.
	semaphore signal.
	^ value! !

Object subclass: #WAErrorPage
	instanceVariableNames: 'exception '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Utilities'!

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:30'!
show
	self session returnResponse:
		(WAGenericResponse new nextPutAll:
			'<h1>Error</h1> There has been an internal error.  The system administrator has been notified.')! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:45'!
printExceptionDescriptionOn: aResponse
	aResponse nextPutAll: '<h1>', exception description, '</h1>'.
	! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:45'!
printStackFrameListStartOn: aResponse
	aResponse nextPutAll: '<ul>'! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:45'!
printStackFrameListEndOn: aResponse
	aResponse nextPutAll: '</ul>'! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:52'!
printFooterForStackFrame: aContext on: aResponse
	aResponse nextPutAll: '</table></blockquote></li>'.	! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:44'!
printWalkbackOn: aResponse
	|context|
	self printExceptionDescriptionOn: aResponse.
	self printStackFrameListStartOn: aResponse.

	context _ thisContext. 
	[context receiver isKindOf: Exception] whileFalse: [context _ context sender].
	[context receiver isKindOf: Exception] whileTrue: [context _ context sender].
	[context notNil] whileTrue: [
		self printStackFrame: context on: aResponse.
		context _ context sender].

	self printStackFrameListEndOn: aResponse.! !

!WAErrorPage class methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 18:37'!
exception: anException
	^ self new exception: anException! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ac 8/29/2003 14:58'!
printStackFrame: aContext on: aResponse
	self printHeaderForStackFrame: aContext on: aResponse.
	self printObject: aContext receiver labelled: 'self' on: aResponse.
		
	aContext tempNames withIndexDo:
		[:name :index |
		self printObject: (aContext tempAt: index) labelled: name on: aResponse].

	self printFooterForStackFrame: aContext on: aResponse.! !

WAErrorPage subclass: #WAWalkbackPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Utilities'!

!WAWalkbackPage methodsFor: 'as yet unclassified' stamp: 'JF 5/28/2003 00:17'!
responseWithUrl: urlString
	|response|
	response _ WAGenericResponse new.
	response nextPutAll: '<small>'.
	#(debug) do: [:ea | self printOption: ea on: response withUrl: urlString].
	response nextPutAll: '</small><br />'.
	
	self printWalkbackOn: response.
	^ response
! !

!WAWalkbackPage methodsFor: 'as yet unclassified' stamp: 'ab 6/16/2003 00:06'!
debug
	exception defaultAction! !

!WAWalkbackPage methodsFor: 'as yet unclassified' stamp: 'ab 1/13/2003 22:51'!
printOption: aSymbol on: response withUrl: urlString
	response
		nextPutAll: '<a href="';
		nextPutAll: urlString;
		nextPutAll: '?debug=';
		nextPutAll: aSymbol;
		nextPutAll: '">';
		nextPutAll: aSymbol capitalized;
		nextPutAll: '</a> '.
! !

!WAWalkbackPage methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 19:20'!
show
	| req |
	self session redirect.
	req _ self session respond: [:url | self responseWithUrl: url].
	self perform: (req at: 'debug') asSymbol.! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 18:39'!
session
	^ WASession currentSession! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ac 8/29/2003 15:07'!
printObject: anObject labelled: aString on: aResponse
	| objectString |
	[objectString _ anObject printStringLimitedTo: 100]
		on: Error
		do: [objectString _ '<font color="FF0000">&lt;error in printStringLimitedTo:&gt;</font>'].
	aResponse
		nextPutAll: '<tr><td>', aString, '</td>';
		nextPutAll: '<td>';
		nextPutAll: objectString;
		nextPutAll: '</td></tr>'! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:49'!
printHeaderForStackFrame: aContext on: aResponse
	aResponse
		nextPutAll: '<li>';
		nextPutAll: aContext fullPrintString;
		nextPutAll: '<blockquote><table border="1">'
		
	! !

WAErrorPage subclass: #WAEmailErrorPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Utilities'!

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:57'!
printFooterForStackFrame: aContext on: aStream
	aStream nextPutAll: '--------'! !

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:57'!
printExceptionDescriptionOn: aResponse
	aResponse nextPutAll: exception description; cr! !

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:55'!
printObject: anObject labelled: aString on: aStream
	aStream space; space; space; nextPutAll: aString.
	(20 - aString size) timesRepeat: [aStream space].
	aStream nextPutAll: (anObject printStringLimitedTo: 100).
	aStream cr.! !

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:22'!
show
	SeasidePlatformSupport deliverMailFrom: 'seaside@beta4.com' to: self emailAddresses text: self emailText.
	super show! !

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:26'!
emailText
	^ String streamContents:
		[:s |
		self printWalkbackOn: s]! !

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:55'!
printStackFrameListEndOn: aStream! !

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:56'!
printHeaderForStackFrame: aContext on: aStream
	aStream cr; nextPutAll: aContext fullPrintString	; cr
	! !

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 23:55'!
printStackFrameListStartOn: aStream! !

!WAEmailErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 00:09'!
emailAddresses
	^ #('root@localhost')! !

!WAErrorPage methodsFor: 'as yet unclassified' stamp: 'ab 5/27/2003 18:37'!
exception: anException
	exception _ anException! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'children name attributes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Document'!

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:58'!
isKnownTag
	^ self knownTags includes: self name! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 12:58'!
renderOn: html indentLevel: level
	html break.
	level timesRepeat: [html space].
	
	self renderOpenTagOn: html.
	self childrenDo: [:ea | ea renderOn: html indentLevel: level + 1].
	self shouldPrintCloseTag ifTrue:
		[self shouldIndentCloseTag ifTrue:
			[html break.
			level timesRepeat: [html space]].
		self renderCloseTagOn: html].! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:53'!
renderCloseTagOn: html 
	html encodeText: '</'.
	html spanClass: self cssClass with: [html encodeText: self name].
	html encodeText: '>'.! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:17'!
shouldIndentCloseTag
	^ children notNil and: [children anySatisfy: [:ea | ea isString not]]! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:49'!
cssClass
	^ self isKnownTag ifTrue: ['tag-known'] ifFalse: ['tag-unknown']! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:10'!
childrenDo: aBlock
	children ifNotNil: [children do: aBlock]! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:44'!
printOpenTagOn: aStream 
	aStream
		nextPut: $<;
		nextPutAll: self name.
	attributes printHtmlOn: aStream.
	self shouldPrintCloseTag ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:47'!
name
	^ name asLowercase! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString attributes: anAttributes
	^ self new initializeWithName: aString attributes: anAttributes! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString
	^ self named: aString attributes: (WAHtmlAttributes new)! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:47'!
shouldPrintCloseTag
	^(#(#hr #br #input #img) includes: self name) not! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:10'!
printHtmlOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea printHtmlOn: aStream].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:14'!
attributeAt: aString put: anObject
	attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 1/11/2003 13:47'!
add: anElement
	children ifNil: [children _ OrderedCollection new].
	children add: anElement.! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:16'!
initializeWithName: aString attributes: anAttributes
	name _ aString.
	attributes _ anAttributes! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:38'!
knownTags
	^ #(?xml
!!doctype
!!dt
a
abbr
acronym
address
applet
area
attach
b
base
basefont
bdo
big
blink
blockquote
body
br
button
caption
center
cite
code
col
colgroup
comment
component
dd
del
dfn
dir
div
dl
dt
em
fieldset
font
form
frame
frameset
h
h1
h2
h3
h4
h5
h6
head
hr
html
i
iframe
img
input
ins
isindex
kbd
label
legend
li
link
listing
map
menu
meta
multicol
nextid
nobr
noframes
noscript
object
ol
optgroup
option
p
param
plaintext
pre
q
s
samp
script
select
small
span
strike
strong
style
sub
sup
table
tbody
td
textarea
textflow
tfoot
th
thead
title
tr
tt
u
ul
var
wbr
xmp)! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:44'!
printCloseTagOn: aStream 
	aStream
		nextPutAll: '</';
		nextPutAll: self name;
		nextPut: $>! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:50'!
renderOpenTagOn: html 
	html encodeText: '<'.
	html spanClass: self cssClass with: [html encodeText: self name].
	
	attributes renderOn: html.
	
	self shouldPrintCloseTag 
		ifFalse: [html space; encodeText: '/'].
	html encodeText: '>'.! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Utilities'!

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:37'!
at: key put: val
	|removals|
	table at: key put: val.
	ageTable at: val put: 0.
	removals _ OrderedCollection new.
	ageTable associationsDo:
		[:assoc |
		assoc value > max ifTrue: [removals add: assoc key].
		assoc value: assoc value + 1].
	removals do: [:ea | self remove: ea].
	! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max _ aNumber! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:55'!
nextKey
	|key|
	[table includesKey: (key _ WAExternalID new asString)] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:23'!
store: anObject
	|key|
	key _ self nextKey.
	self at: key put: anObject.
	^ key! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:18'!
at: key
	^ self at: key ifAbsent: [self error: 'No entry for ', key]! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:28'!
at: key ifAbsent: errorBlock
	|val|
	val _ table at: key ifAbsent: [^ errorBlock value].
	ageTable at: val put: 0.
	^ val.! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:48'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:18'!
new
	^ super new initialize! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 19:07'!
initialize
	max _ 20.
	table _ Dictionary new.
	ageTable _ Dictionary new.! !

!WALRUCache class methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

Object subclass: #WAPluggableSelectBox
	instanceVariableNames: 'changeSelected model selected size list '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:25'!
size: aNumber
	size _ aNumber! !

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:27'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector size: aNumber
	^ self new
		model: anObject;
		list: listSelector;
		selected: selectedSelector;
		changeSelected: changeSelectedSelector;
		size: aNumber! !

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:28'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector
	^ self 
		on: anObject
		list: listSelector
		selected: selectedSelector
		changeSelected: changeSelectedSelector
		size: 10! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:24'!
model: anObject
	model _ anObject! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderOn: html
	|array|
	array _ (model perform: list) asArray.
	html divClass: 'column-choice' with:	
		[html form:
			[html attributeAt: 'size' put: size.
			html attributeAt: 'onChange' put: 'submit()'.
			html
				selectFromList: array
				selected: (array at: (model perform: selected) ifAbsent: [])
				callback: [:item | model perform: changeSelected with: (array indexOf: item)]]].	! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
changeSelected: aSymbol
	changeSelected _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
list: aSymbol
	list _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
selected: aSymbol
	selected _ aSymbol! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'actionUrl callbacks document '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Core'!

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document _ anObject! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
callbacks
	"Answer the value of callbacks"

	^ callbacks! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl: anObject
	"Set the value of actionUrl"

	actionUrl _ anObject! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
callbacks: anObject
	"Set the value of callbacks"

	callbacks _ anObject! !

Object subclass: #WARequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Handlers'!

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 13:43'!
isActive
	^ true! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 12:22'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document _ anObject.
	mimeType _ mimeString.
	mimeDocument _ document asMIMEDocument.
	fileName _ fileString.! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 12:33'!
response
	| response |
	response _ WAGenericResponse new.
	response nextPutAll: mimeDocument content contents.
	response contentType: (mimeType ifNil: [mimeDocument contentType]).
	response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
	fileName ifNotNil: 
		[response headerAt: 'Content-Disposition' put: 'attachment; filename=' , fileName].
	^ response! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:41'!
= other
	^ (other species = self species
		and: [other document = self document])
		and: [other mimeType = self mimeType]! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:43'!
handleRequest: aRequest
	^ self response! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler class methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 12:23'!
document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 12:33'!
handleRequest: aRequest
	self subclassResponsibility! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'basePath '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:48'!
configurationComponent
	^ nil! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:08'!
basePath: aString
	basePath _ aString! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:08'!
basePath
	^ basePath! !

!WAEntryPoint methodsFor: 'printing' stamp: 'JF 9/22/2003 20:06'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self basePath, ')'! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

WADispatcher class
	instanceVariableNames: 'default '!

!WADispatcher methodsFor: 'public' stamp: 'ab 7/10/2003 11:48'!
removeEntryPoint: anObject
	entryPoints removeKey: (entryPoints keyAtValue: anObject)! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'JF 9/15/2003 14:40'!
default
	default ifNil: [default _ self new].
	default basePath ifNil: [default basePath: '/seaside'].
	
	^ default! !

!WADispatcher methodsFor: 'public' stamp: 'ab 5/26/2003 00:10'!
handleRequest: aRequest
	^ (self handlerForRequest: aRequest) handleRequest: aRequest! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:47'!
description
	^ 'Subdirectory'! !

!WADispatcher methodsFor: 'private' stamp: 'ab 8/26/2003 21:55'!
handlerForRequest: aRequest
	| path name |
	path _ aRequest url.
	(path beginsWith: basePath)
		ifTrue: [name _ ((path allButFirst: basePath size) findTokens: '/') at: 1 ifAbsent: [].
				entryPoints at: name ifPresent: [:n | ^ n]].
	^ WANotFoundHandler new! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:53'!
configurationComponent
	^ WADispatcherEditor new dispatcher: self! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:09'!
new
	^ super new initialize! !

!WADispatcher methodsFor: 'private' stamp: 'ab 8/26/2003 21:08'!
initialize
	entryPoints _ Dictionary new! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:11'!
registerEntryPoint: entryPoint at: aString
	entryPoints at: aString put: entryPoint.
	entryPoint basePath: basePath, '/', aString.! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:51'!
concreteSubclasses
	^ self allSubclasses reject: [:ea | ea isAbstract]! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

!WARegistry methodsFor: 'private' stamp: 'ab 5/28/2003 23:52'!
registerRequestHandler: anObject
	|key|
	key _ WAExternalID new: 16.
	self shouldCollectHandlers ifTrue: [self collectExpiredHandlers].
	handlersByKey at: key put: anObject.
	keysByHandler at: anObject put: key.
	^ key! !

!WARegistry methodsFor: 'private' stamp: 'ab 6/9/2003 22:56'!
collectExpiredHandlers
	(handlersByKey reject: [:ea | ea isActive]) do: [:ea | self unregisterRequestHandler: ea]! !

!WARegistry methodsFor: 'private' stamp: 'ab 6/9/2003 22:55'!
unregisterRequestHandler: anObject
	handlersByKey removeKey: (keysByHandler at: anObject).
	keysByHandler removeKey: anObject! !

!WARegistry methodsFor: 'private' stamp: 'ab 6/9/2003 22:56'!
handleKeyRequest: aRequest
	|key handler|
	key _ [WAExternalID fromString: aRequest handlerKey] on: Error do: [nil].
	handler _ handlersByKey at: key ifAbsent: [nil].
	^ (handler notNil and: [handler isActive])
		ifTrue: [handler handleRequest: aRequest]
		ifFalse: [self handleExpiredRequest: aRequest]! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
shouldCollectHandlers
	^ 10 atRandom = 1! !

!WARegistry methodsFor: 'public' stamp: 'ab 5/29/2003 00:02'!
handleRequest: aRequest
	^ aRequest hasHandlerKey
		ifTrue: [self handleKeyRequest: aRequest]
		ifFalse: [self handleDefaultRequest: aRequest]
! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
initialize
	self clearHandlers.! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:30'!
handleExpiredRequest: aRequest
	^ self handleDefaultRequest: aRequest! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:29'!
handleDefaultRequest: aRequest
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
expiredHandlerForRequest: aRequest
	^ self createHandlerForRequest: aRequest! !

!WARegistry methodsFor: 'public' stamp: 'ab 5/18/2003 12:26'!
urlForRequestHandler: anObject path: pathString
	|key|
	key _ keysByHandler at: anObject ifAbsent: [self registerRequestHandler: anObject].
	^ pathString, self class handlerKeySeparator, key asString! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'JF 9/22/2003 20:15'!
clearAllHandlers
	self allSubInstances do: [:ea | ea clearHandlers]! !

!WARegistry methodsFor: 'public' stamp: 'ab 5/26/2003 01:34'!
urlForRequestHandler: anObject
	^ self urlForRequestHandler: anObject path: self basePath! !

WARegistry subclass: #WAApplication
	instanceVariableNames: 'preferences sessionClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

!WAApplication methodsFor: 'preferences' stamp: 'ab 5/28/2003 11:54'!
preferenceAt: aSymbol put: anObject
	| pref |
	pref _ preferences detect: [:a | a key = aSymbol] ifNone: [].
	pref isNil
		ifTrue: [preferences add: (WAPreference key: aSymbol value: anObject)]
		ifFalse: [pref value: anObject].
	^ anObject! !

!WAApplication methodsFor: 'preferences' stamp: 'JF 6/10/2003 16:52'!
preferenceAt: aSymbol
	^ (preferences 
		detect: [:ea | ea key = aSymbol]
		ifNone: [self sessionClass defaultPreferences detect: [:ea | ea key = aSymbol]]) value! !

!WAApplication methodsFor: 'basic configuration' stamp: 'ab 7/18/2002 23:14'!
sessionClass
	^ sessionClass! !

!WAApplication class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:45'!
path: pathString
	^ self new basePath: pathString! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:34'!
configurationComponent
	^ WAApplicationEditor new application: self! !

!WAApplication methodsFor: 'initialization' stamp: 'ab 8/27/2003 00:08'!
initialize
	super initialize.
	sessionClass _ WAControllerSession.
	preferences _ OrderedCollection new.
	self takePreferences: sessionClass defaultPreferences.! !

!WAApplication methodsFor: 'basic configuration' stamp: 'ab 1/15/2003 01:04'!
sessionClass: aClass
	sessionClass _ aClass.
	self takePreferences: sessionClass defaultPreferences.! !

!WAApplication methodsFor: 'preferences' stamp: 'JF 6/17/2003 15:41'!
takePreferences: aCollection
	| oldPreferences |
	oldPreferences _ preferences.
	preferences _ aCollection asOrderedCollection.
	
	"We may want to deal with the case where the type of a preference is different than it used to be"
	oldPreferences do: [:pref | self preferenceAt: pref key put: pref value]! !

!WAApplication methodsFor: 'request handling' stamp: 'ab 5/26/2003 01:52'!
handleDefaultRequest: aRequest
	|session|
	session _ sessionClass application: self.
	^ session enterSessionWithRequest: aRequest! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 5/26/2003 01:22'!
name
	^ (basePath findTokens: '/') last! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 1/15/2003 00:54'!
preferences
	^ preferences! !

!WAApplication class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:47'!
description
	^ 'Seaside Application'! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 12:26'!
handlerKeySeparator
	^ '/@'! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
clearHandlers
	handlersByKey _ Dictionary new.
	keysByHandler _ Dictionary new.! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:45'!
new
	^ super new initialize! !

WARequestHandler subclass: #WASession
	instanceVariableNames: 'continuations application escapeContinuation expiryContinuation monitor path filters lastAccess state isActive initialRequest '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

!WASession methodsFor: 'accessing' stamp: 'ab 5/26/2003 01:38'!
performRequest: aRequest
	lastAccess _ Time totalSeconds.
	(continuations at: aRequest actionKey ifAbsent: [[:r | self unknownRequest: r]])
		value: aRequest! !

!WASession methodsFor: 'state' stamp: 'ab 2/18/2003 18:50'!
footprint
	^ state calculateFootprint! !

!WASession methodsFor: 'state' stamp: 'ab 2/18/2003 18:51'!
registerObjectForBacktracking: anObject
	state registerObject: anObject! !

!WASession methodsFor: 'accessing' stamp: 'avi 10/25/2003 23:27'!
initialRequest
	^ initialRequest! !

!WASession methodsFor: 'filters' stamp: 'ab 2/19/2003 01:48'!
once: aBlock
	self filter: WAOnce new do: aBlock! !

!WASession methodsFor: 'request handling' stamp: 'ab 1/6/2003 13:47'!
unknownRequest: aRequest
	self pageExpired! !

!WASession methodsFor: 'state' stamp: 'ab 2/18/2003 18:49'!
wrapContinuation: aContinuation
	|snap|
	snap _ state snapshot.
	^ [:v | state restoreSnapshot: snap. aContinuation value: v]! !

!WASession methodsFor: 'printing' stamp: 'ab 5/26/2003 01:38'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', (application urlForRequestHandler: self), ')'! !

!WASession methodsFor: 'filters' stamp: 'ab 2/15/2003 20:24'!
removeFilter: aFilter
	filters contents: (filters contents copyWithout: aFilter)! !

WASession subclass: #WAControllerSession
	instanceVariableNames: 'root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Core'!

WAControllerSession subclass: #WAWikiSession
	instanceVariableNames: 'wiki '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Wiki'!

!WAWikiSession methodsFor: 'as yet unclassified' stamp: 'ab 11/27/2002 00:16'!
textAt: aString
	^ wiki perform: aString asLegalSelector asSymbol! !

!WAWikiSession methodsFor: 'as yet unclassified' stamp: 'ab 11/27/2002 00:17'!
textAt: aString put: textString
	^ wiki class compile:
		aString asLegalSelector, String cr,
		'"', aString, '"',
		'^ ', String cr,
		textString printString! !

!WAWikiSession methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 01:49'!
createRootFromRequest: aRequest
	|sel viewer|
	viewer _ WAWikiViewer new.
	sel _ (aRequest path copyAfterLast: $/) asLegalSelector asSymbol.
	(wiki respondsTo: sel)
		ifTrue: [viewer link: sel]
		ifFalse: [viewer link: #start].
	^ viewer! !

!WAWikiSession methodsFor: 'as yet unclassified' stamp: 'ab 11/27/2002 00:10'!
initialize
	super initialize.
	wiki _ WAWikiWiki new.! !

!WAControllerSession methodsFor: 'rendering' stamp: 'ab 3/20/2003 11:44'!
alwaysRedirect	
	^ application preferenceAt: #alwaysRedirect! !

WAControllerSession subclass: #WAAuthenticatedSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAAuthenticatedSession methodsFor: 'as yet unclassified' stamp: 'ab 3/20/2003 12:22'!
authenticateUser: username password: password
	^ username = (application preferenceAt: #username)
		and: [password = (application preferenceAt: #password)]! !

!WAAuthenticatedSession methodsFor: 'as yet unclassified' stamp: 'JF 6/9/2003 21:24'!
start: aRequest
	self
		basicAuthentication: [:u :p | self authenticateUser: u password: p]
		do: [super start: aRequest]! !

!WAAuthenticatedSession class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:57'!
defaultPreferences
	^ super defaultPreferences,
		(Array
			with: (WAStringPreference key: #username value: 'seaside')
			with: (WAStringPreference key: #password value: 'admin'))! !

!WAControllerSession methodsFor: 'request handling' stamp: 'avi 10/23/2003 16:18'!
createRootFromRequest: aRequest
	^ (application preferenceAt: #entryPoint) new! !

!WAControllerSession methodsFor: 'request handling' stamp: 'avi 10/24/2003 11:42'!
start: aRequest
	root _ self rootFromRequest: aRequest.
	[self render] repeat! !

WAControllerSession subclass: #WAStoreSession
	instanceVariableNames: 'cart inventory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreSession methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:34'!
inventory
	^ inventory ifNil: [inventory _ WAStoreInventory new]! !

!WAStoreSession methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:34'!
clearCart
	cart _ WAStoreCart new! !

!WAStoreSession methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:37'!
cart
	^ cart! !

!WAControllerSession methodsFor: 'rendering' stamp: 'ab 6/15/2003 16:48'!
responseWithUrl: urlString callbacks: aCallbackStore
	| document |
	document _ WAHtmlResponse new.
	root renderActiveControllerWithContext:
		(WARenderingContext new
			document: document;
			actionUrl: urlString;
			callbacks: aCallbackStore).
	^ document! !

!WAControllerSession methodsFor: 'responding' stamp: 'jf 11/24/2003 11:34'!
defaultResponse
	self render! !

!WAControllerSession methodsFor: 'rendering' stamp: 'ab 6/15/2003 16:48'!
render
	|request callbacks|
	[self bookmarkForExpiry.
	self alwaysRedirect ifTrue: [self redirect].

	callbacks _ WACallbackStore new.
	request _ [self respond: [:url | self responseWithUrl: url callbacks: callbacks]]
					on: WASimulatedRequestNotification
					do: [:n | n request].
	callbacks processRequest: request]
		on: WARenderNotification
		do: [:n]! !

!WAControllerSession class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:57'!
defaultPreferences
	^ 	super defaultPreferences,
			(Array with: (WAListPreference key: #entryPoint value: WACounter options: self entryPoints))! !

!WAControllerSession class methodsFor: 'as yet unclassified' stamp: 'ab 3/20/2003 12:10'!
entryPoints
	^ WAController allSubclasses asSortedCollection: [:a :b | a name <= b name]! !

!WAControllerSession methodsFor: 'request handling' stamp: 'avi 10/23/2003 16:17'!
rootFromRequest: aRequest
	|component|
	component _ self createRootFromRequest: aRequest.
	^ (application preferenceAt: #showToolbar)
		ifTrue: [WAToolFrame on: component]
		ifFalse: [component]! !

!WASession methodsFor: 'request handling' stamp: 'avi 9/26/2003 17:41'!
enterSession: aBlock
	^ monitor critical: [self withEscapeContinuation: [self withErrorHandler: [self redirect. aBlock value]]]! !

!WASession methodsFor: 'responding' stamp: 'jf 11/24/2003 11:33'!
defaultResponse
	^ WAGenericResponse new! !

!WASession methodsFor: 'accessing' stamp: 'ab 5/26/2003 01:53'!
addToPath: aString
	path contents: self basePath, '/', aString! !

!WASession methodsFor: 'responding' stamp: 'ab 6/15/2003 23:17'!
respond: responseBlock
	|request|
	request _ 
	Continuation currentDo:
		[:cc ||url|
		url _ self actionUrlForContinuation: cc.
		self returnResponse: (responseBlock value: url)].
	
	filters contents do: [:ea | ea handleRequest: request inSession: self].
	^ request ! !

!WASession methodsFor: 'responding' stamp: 'ab 2/12/2003 20:21'!
actionUrlForContinuation: aContinuation
	^ self actionUrlForKey: (continuations store: (self wrapContinuation: aContinuation))! !

!WASession methodsFor: 'responding' stamp: 'ab 2/5/2003 17:15'!
redirect
	self respond: [:url | WARedirectResponse location: url]! !

!WASession methodsFor: 'accessing' stamp: 'ab 5/26/2003 01:34'!
basePath
	^ application basePath! !

!WASession methodsFor: 'request handling' stamp: 'ab 3/20/2003 11:36'!
start
	self subclassResponsibility! !

!WASession methodsFor: 'accessing' stamp: 'ac 9/15/2003 14:40'!
isActive
	^ isActive and: 
		[Time totalSeconds - lastAccess < (self application preferenceAt: #sessionExpirySeconds)]! !

!WASession methodsFor: 'responding' stamp: 'ab 2/5/2003 17:34'!
redirectWithMessage: aString delay: aNumber
	self respond:
		[:url |
		WARefreshResponse
			message: aString
			location: url
			delay: aNumber].
! !

!WASession class methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 15:12'!
currentSession
	|context|
	context _ thisContext.
	[context isNil] whileFalse:
		[(context receiver isKindOf: self) ifTrue: [^ context receiver].
		context _ context sender].
	^ nil
! !

!WASession methodsFor: 'initializing' stamp: 'ab 5/26/2003 01:53'!
initialize! !

!WASession methodsFor: 'request handling' stamp: 'ab 5/27/2003 23:41'!
errorPageClass
	^ application preferenceAt: #errorPage! !

!WASession methodsFor: 'request handling' stamp: 'ab 8/28/2003 20:10'!
withErrorHandler: aBlock
	^ [aBlock
		on: Error
		do: (MessageSend receiver: self selector: #handleError:)]
		on: Warning
		do: (MessageSend receiver: self selector: #handleWarning:)! !

!WASession methodsFor: 'request handling' stamp: 'ab 5/26/2003 01:20'!
responseForRequest: aRequest
	^ self responseFor: [self performRequest: aRequest]! !

!WASession class methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 01:53'!
application: anApplication
	^ self new initializeWithApplication: anApplication! !

!WASession methodsFor: 'expiring' stamp: 'ac 9/15/2003 14:40'!
expire
	isActive _ false! !

!WASession methodsFor: 'accessing' stamp: 'ab 3/20/2003 11:43'!
application
	^ application! !

!WASession methodsFor: 'filters' stamp: 'JF 5/16/2003 17:52'!
filter: aFilter do: aBlock
	self addFilter: aFilter.
	aBlock value.
	self removeFilter: aFilter! !

!WASession methodsFor: 'responding' stamp: 'ab 5/26/2003 01:40'!
actionUrlForKey: aString
	^ (application urlForRequestHandler: self path: self path), '/', aString! !

!WASession methodsFor: 'filters' stamp: 'ab 2/15/2003 20:25'!
basicAuthentication: authBlock do: aBlock
	self filter: (WABasicAuthentication new authenticationBlock: authBlock) do: aBlock! !

!WASession methodsFor: 'request handling' stamp: 'JF 5/16/2003 18:23'!
start: aRequest
	^ self start! !

!WASession methodsFor: 'request handling' stamp: 'ab 5/26/2003 01:16'!
handleRequest: aRequest
	^ monitor critical: [self responseForRequest: aRequest]
! !

!WASession methodsFor: 'filters' stamp: 'ab 2/15/2003 20:24'!
addFilter: aFilter
	filters contents: (filters contents copyWith: aFilter)! !

!WASession methodsFor: 'request handling' stamp: 'ab 8/28/2003 20:11'!
handleWarning: aWarning
	(WAWarningPage warning: aWarning) show! !

!WASession methodsFor: 'expiring' stamp: 'ac 9/15/2003 14:32'!
bookmarkForExpiry
	^ Continuation currentDo:
		[:cc |
		expiryContinuation _
			self wrapContinuation:
				[:v |
				self redirectWithMessage: 'That page has expired.' delay: 3.
				cc value: v] fixTemps] ! !

!WASession methodsFor: 'responding' stamp: 'ac 5/30/2003 13:40'!
redirectTo: urlString
	self returnResponse: (WARedirectResponse location: urlString)! !

!WASession methodsFor: 'filters' stamp: 'ab 2/15/2003 20:25'!
isolate: aBlock
	|txn|
	txn _ WATransaction new.
	self filter: txn do: aBlock.
	txn close.
	self bookmarkForExpiry.
! !

!WASession methodsFor: 'request handling' stamp: 'jf 11/24/2003 11:33'!
withEscapeContinuation: aBlock
	^ Continuation currentDo:
			[:cc |
			escapeContinuation := cc.
			aBlock value.
			self defaultResponse]! !

!WASession methodsFor: 'initializing' stamp: 'ac 9/15/2003 14:49'!
initializeWithApplication: anApplication
	application _ anApplication.
	continuations _ WALRUCache new.
	monitor _ WAProcessMonitor new.
	state _ WAStateRegistry new.
	expiryContinuation _ [:r | self start].
	lastAccess _ Time totalSeconds.
	filters _ WAStateHolder new contents: #().
	path _ WAStateHolder new contents: self basePath.
	isActive _ true.
	self initialize.! !

!WASession methodsFor: 'request handling' stamp: 'ab 3/5/2003 20:44'!
responseFor: aBlock
	^ self withEscapeContinuation: [aBlock value]! !

!WASession methodsFor: 'request handling' stamp: 'ab 8/26/2003 18:52'!
handleError: e
		e reactivateHandler.
		(self errorPageClass exception: e)
		 	show.! !

!WASession methodsFor: 'request handling' stamp: 'avi 10/25/2003 23:27'!
enterSessionWithRequest: aRequest
	initialRequest _ aRequest.
	^ self enterSession: [self start: aRequest]! !

!WASession methodsFor: 'accessing' stamp: 'ab 5/26/2003 01:53'!
path
	^ path contents! !

!WASession methodsFor: 'expiring' stamp: 'ab 2/12/2003 20:57'!
pageExpired
	expiryContinuation value: nil
	! !

!WASession class methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 16:43'!
defaultPreferences
	^ (OrderedCollection new
		add: (WABooleanPreference key: #showToolbar value: true);
		add: (WABooleanPreference key: #alwaysRedirect value: true);
		add: (WAListPreference key: #errorPage value: WAWalkbackPage options: (WAErrorPage withAllSubclasses));
		add: (WANumberPreference key: #sessionExpirySeconds value: 600);
		yourself) asArray! !

!WASession methodsFor: 'responding' stamp: 'ab 6/15/2003 19:25'!
returnResponse: aResponse
	escapeContinuation value: aResponse! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Handlers'!

!WANotFoundHandler methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 00:07'!
handleRequest: aRequest
	^ WANotFoundResponse location: aRequest path! !

Object subclass: #WAModelProxy
	instanceVariableNames: 'cache model '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Utilities'!

!WAModelProxy methodsFor: 'accessing' stamp: 'ab 11/26/2002 17:22'!
model
	^ model! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
value
	^ model value! !

!WAModelProxy class methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 17:21'!
on: anObject
	^ self new setModel: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:53'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [self performRead: aMessage selector]
		ifFalse:
			[(aMessage selector isKeyword and: [aMessage arguments size = 1])
				ifTrue: [self performWrite: aMessage selector allButLast with: aMessage argument]
				ifFalse: [super doesNotUnderstand: aMessage]]! !

!WAModelProxy methodsFor: 'initializing' stamp: 'ab 12/12/2002 00:18'!
setModel: anObject
	model _ anObject.
	cache _ Dictionary new.! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 12/12/2002 00:18'!
commit
	cache keysAndValuesDo:
		[:key :value |
		self performRealWrite: key with: value].

	cache _ Dictionary new.
! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:50'!
performRead: aSymbol
	^ cache at: aSymbol ifAbsent: [model perform: aSymbol]! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:51'!
performWrite: aSymbol with: anObject
	cache at: aSymbol put: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
name
	^ model name! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 18:39'!
performRealWrite: aSymbol with: anObject
	model perform: (aSymbol,':') asSymbol with: anObject! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/26/2002 20:05'!
renderOn: aRenderer
	aRenderer text: self! !

Object subclass: #WAFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

WAFilter subclass: #WAOnce
	instanceVariableNames: 'seenKeys '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

!WAOnce methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 01:47'!
handleRequest: aRequest inSession: aSession
	(seenKeys includes: aRequest actionKey)
		ifTrue: [aSession pageExpired]
		ifFalse: [seenKeys add: aRequest actionKey]! !

!WAOnce methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 01:47'!
initialize
	seenKeys _ Set new! !

!WAOnce class methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 01:46'!
new
	^ super new initialize! !

!WAFilter methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 13:10'!
handleRequest: aRequest inSession: aSession
	! !

WAFilter subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticationBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 00:56'!
handleRequest: aRequest inSession: aSession
	^ (authenticationBlock value: aRequest user value: aRequest password)
		ifTrue: [aRequest]
		ifFalse: [aSession returnResponse: (WABasicAuthResponse realm: aSession basePath)]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 22:01'!
authenticationBlock: aBlock
	authenticationBlock _ aBlock! !

WAFilter subclass: #WATransaction
	instanceVariableNames: 'active '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 15:41'!
handleRequest: aRequest inSession: aSession
	^ active
		ifTrue: [aRequest]
		ifFalse: [aSession pageExpired].
	! !

!WATransaction class methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
new
	^ super new initialize! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
initialize
	active _ true! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
close
	active _ false! !

Object subclass: #WACallbackStore
	instanceVariableNames: 'count action callbacks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Core'!

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2002 23:23'!
sortRequest: aDictionary
	|sorted|
	sorted _ SortedCollection sortBlock: [:x :y | x key asNumber < y key asNumber].
	aDictionary ifNotNil:
		[aDictionary keysAndValuesDo:
			[:k :v|
			k asInteger ifNotNil:
				[sorted add: k -> (self valueForField: v)]]].
	^ sorted! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:41'!
storeCallback: aCallback
	|key|
	key _ (count _ count + 1) asString.
	callbacks at: key put: aCallback.
	^ key
! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:55'!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackStore class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2002 23:10'!
new
	^ super new initialize! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:49'!
evaluateCallbackAt: callbackKey with: anObject
	(callbacks at: callbackKey) evaluateWithObject: anObject store: self! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:55'!
registerCallback: aBlock
	^ self storeCallback: (WAValueCallback new block: aBlock)! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 10/2/2002 00:19'!
valueForField: field 
	^ field
		ifNil: ['']
		ifNotNil:
			[(field isCollection and: [field isString not])
					ifTrue: [field isEmpty
								ifTrue: ['']
								ifFalse: [field first]]
					ifFalse: [field]]! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:54'!
registerActionCallback: aBlock
	^ self storeCallback: (WAActionCallback new block: aBlock)! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:40'!
initialize
	callbacks _ Dictionary new.
	count _ 0.	! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:51'!
action: anActionCallback
	action _ anActionCallback! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 00:56'!
processRequest: aRequest
	action _ nil.
	(self sortRequest: aRequest fields) do:
		[:assoc | self evaluateCallbackAt: assoc key with: assoc value].
	^ action ifNotNil: [action trigger]! !

Object subclass: #WAHtmlBuilder
	instanceVariableNames: 'document attributeBuffer '
	classVariableNames: 'HtmlCharacters '
	poolDictionaries: ''
	category: 'Seaside/Base-Document'!

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock with: anotherBlock
	self tableRow: [ self tableData: aBlock; tableData: anotherBlock]! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableHeading: aBlock
	self tag: 'th' do: aBlock! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 5/12/2003 11:44'!
openTag: aString
	document pushElement: (WAHtmlElement named: aString attributes: self attributes).
	attributeBuffer _ nil.! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divClass: aString with: anObject
	self cssClass: aString; div: anObject! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 5/27/2003 15:06'!
image: urlString
	self attributeAt: 'src' put: urlString.
	
	self tag: #img.! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock span: aNumber
	self tableRow: [ self attributeAt: 'colspan' put: aNumber. self tableData: aBlock ]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 11/24/2003 11:54'!
list: aCollection do: aBlock
	self tag: #ul do:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:49'!
headTag: aString
	| element |
	element _ WAHtmlElement named: aString attributes: self attributes.
	document head add: element.
	attributeBuffer _ nil.
	^ element! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 5/12/2003 11:27'!
attributeAt: aString put: anObject
	self attributes at: aString put: anObject.
	! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 1/11/2003 12:44'!
attributes: aCollection
	aCollection associationsDo: [:x | self attributeAt: x key put: x value]! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'ab 2/12/2003 23:39'!
document: aDocument
	document _ aDocument! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ac 5/16/2003 16:11'!
render: anObject
	anObject renderOn: self! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 6/10/2003 19:19'!
anchorWithUrl: urlString title: titleString do: aBlock
	self attributes	title: titleString.
	self anchorWithUrl: urlString do: aBlock.! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:26'!
inputWithType: type
	self inputWithType: type named: nil
! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
div: aBlock
	self tag: 'div' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 5/27/2003 15:10'!
image: urlString altText: altString
	self attributeAt: 'alt' put: altString.
	
	self image: urlString! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 5/12/2003 11:27'!
attributes
	^ attributeBuffer ifNil: [attributeBuffer _ WAHtmlAttributes new]! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'ab 2/12/2003 19:42'!
document
	^ document! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:53'!
buttonForUrl: urlString withText: labelString data: assocCollection
	self formWithMethod: 'GET' action: urlString do:
		[assocCollection do: 
			[:each | self
				inputWithType: 'hidden'
				named: each key asString
				value: each value].
		self submitButtonWithText: labelString]
! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/11/2003 17:01'!
italic: aBlock
	self tag: 'i' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanClass: aString with: anObject
		self cssClass: aString; span: anObject! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
title: aString
	self headTag: 'title' with: aString! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:57'!
inputWithType: type named: name value: value
	name ifNotNil: [self attributes name: name].
	value ifNotNil: [self attributes value: value asString].
		
	self attributes type: type.
	
	self tag: 'input'.
! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
span: aBlock
	self tag: 'span' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 5/27/2003 15:17'!
image: urlString width: width height: height altText: altString
	self attributeAt: 'alt' put: altString.
	
	self image: urlString width: width height: height! !

!WAHtmlBuilder methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:41'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self tag: aMessage selector].
	argCount = 1 ifTrue: [^ self tag: aMessage selector allButLast do: aMessage argument].
	^ super doesNotUnderstand: aMessage
! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
headTag: aString with: child
	(self headTag: aString) add: child asString! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:29'!
tableRowWithLabel: anObject column: aBlock
	self tableRow: [
		self cssClass: 'label'.
		self tableData: anObject.
		self tableData: aBlock]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
break
	self tag: 'br'! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ac 5/16/2003 15:46'!
tag: aString do: anObject
	self openTag: aString.
	self render: anObject.
	self close.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
heading: anObject level: aNumber
	self tag: 'h', aNumber asString do: anObject! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssId: aString
	self attributeAt: 'id' put: aString! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph: aBlock
	self tag: 'p' do: aBlock! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssClass: aString
	self attributeAt: 'class' put: aString! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'ab 7/3/2003 14:56'!
buttonForUrl: urlString withText: labelString
	self buttonForUrl: urlString withText: labelString data: #()
! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock
	self tableRow: [ self tableData: aBlock ]! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableData: aBlock
	self tag: 'td' do: aBlock! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 5/30/2003 00:29'!
spacerRow
	self tableRowWith: [self space]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 8/7/2003 17:22'!
space: aNumber
	aNumber timesRepeat: [self text: '&nbsp;']! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
metaTagNamed: nameString content: contentString
	self attributes
		at: 'name' put: nameString;
		at: 'content' put: contentString.
	self headTag: 'meta'.! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'JF 6/10/2003 18:12'!
layoutTableOfWidth: width do: aBlock
	self attributes width: width.
	self layoutTable: aBlock! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:25'!
inputWithType: type named: name	
	self inputWithType: type named: name value: nil.
! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:19'!
submitButtonWithText: aString
	self attributes value: aString.
	self inputWithType: 'submit'
! !

WAHtmlBuilder subclass: #WAHtmlRenderer
	instanceVariableNames: 'actionUrl callbacks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Builder'!

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 2/12/2003 19:41'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'JF 10/14/2003 11:29'!
form: aBlock
	self
		formWithUrl: actionUrl
		method: 'POST'
		do: aBlock
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'IP 10/31/2003 12:26'!
openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName
	self attributeAt: 'href' put: (self urlForDocument: anObject mimeType: mimeType fileName: fileName).
	self openTag: #a.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
anchorWithAction: actionBlock text: aString
	self openAnchorWithAction: actionBlock.
	self text: aString.
	self close.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ac 11/27/2003 17:53'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock
	self openSelect.
	callbackBlock fixTemps.

	aCollection do:
		[:item |
		self
			optionWithLabel: (labelsBlock value: item)
			selected: (item = selectedObject)
			callback: [callbackBlock value: item]].
	self close.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'jf 11/21/2003 17:47'!
checkboxWithValue: aBoolean callback: callbackBlock
	| value |
	value _ ValueHolder new.
	self hiddenInputWithCallback: [value contents: false].

	self attributeAt: 'checked' put: aBoolean.
	self 
		valueInputOfType: 'checkbox'
		value: 'true'
		callback: [value contents: true]. 
		
	callbackBlock fixTemps.
	self hiddenInputWithCallback: [callbackBlock value: value contents].
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:27'!
context
	^ WARenderingContext new
		document: document;
		actionUrl: actionUrl;
		callbacks: callbacks! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'ab 2/18/2003 19:39'!
fileUploadWithCallback: aBlock
	self inputWithType: 'file' named: (callbacks registerCallback: aBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'ab 1/11/2003 13:28'!
submitButtonWithAction: actionBlock
	self inputWithType: 'submit'
		named: (callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForList: aCollection on: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self
			selectFromList: aCollection
			selected: (anObject perform: aSymbol)
			callback: (self callbackForSelector: aSymbol of: anObject)]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'ab 1/11/2003 13:28'!
radioGroup
	^ callbacks registerDispatchCallback.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'ab 1/16/2003 16:06'!
textAreaWithValue: value callback: callbackBlock
	|callback|
	callback _ value
					ifNil: [[:v | callbackBlock value: (v = '' ifTrue: [nil] ifFalse: [v])]]
					ifNotNil: [callbackBlock].
	self attributeAt: 'name' put: (callbacks registerCallback: callback).
	self openTag: 'textarea'.
	self render: value.
	self close.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
submitButtonWithAction: aBlock text: aString
	self attributeAt: 'value' put: aString.
	self submitButtonWithAction: aBlock! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
anchorWithDocument: anObject mimeType: mimeType text: aString
	self anchorWithDocument: anObject mimeType: mimeType fileName: nil text: aString! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:14'!
passwordInputWithCallback: callbackBlock
	self
		valueInputOfType: 'password'
		value: ''
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForCheckboxOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self checkboxOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 5/6/2003 18:37'!
booleanMenuWithValue: aBoolean callback: callbackBlock labels: labelArray
	self
		selectFromList: (Array with: true with: false)
		selected: aBoolean
		callback: callbackBlock
		labels: [:b | b ifTrue: [labelArray first] ifFalse: [labelArray second]]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
submitButtonOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		submitButtonWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/25/2003 23:03'!
selectInputOn: selectedSymbol of: anObject list: aCollection
	self
		selectFromList: aCollection
		selected: (anObject perform: selectedSymbol)
		callback: (self callbackForSelector: selectedSymbol of: anObject)! !

!WAHtmlRenderer class methodsFor: 'as yet unclassified' stamp: 'ab 2/13/2003 01:25'!
fromContext: aRenderingContext
	^ self new
		document: aRenderingContext document;
		actionUrl: aRenderingContext actionUrl;
		callbacks: aRenderingContext callbacks;
		yourself! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'JF 5/26/2003 09:47'!
urlForAction: actionBlock
	^ actionUrl, '?', (callbacks registerActionCallback: actionBlock)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:15'!
textInputWithCallback: callbackBlock
	self textInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 4/8/2003 14:26'!
anchorWithAction: actionBlock form: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:30'!
labelledRowForTextInputOn: aSymbol of: anObject size: sizeIntegerOrNil
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[sizeIntegerOrNil ifNotNil: [self attributeAt: #size put: sizeIntegerOrNil].
		self textInputOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'ab 1/11/2003 13:28'!
callbacks
	^ callbacks! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:24'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ WASession currentSession application urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 1/11/2003 13:28'!
anchorWithDocument: anObject text: aString
	self anchorWithDocument: anObject mimeType: nil text: aString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'IP 10/31/2003 12:36'!
anchorWithDocument: anObject mimeType: mimeType fileName: fileName text: aString
	self openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName.
	self text: aString.
	self close.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'JF 5/27/2003 15:18'!
imageWithForm: aForm
	self image: (self urlForDocument: aForm) width: aForm width height: aForm height! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 7/11/2003 00:09'!
parseImageMap: aString
	|s x y|
	('?*,*' match: aString) ifFalse: [^ nil].
	s _ aString readStream.
	s upTo: $?.
	x _ s upTo: $,.
	y _ s upToEnd.
	^ x asNumber @ y asNumber
	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
hiddenInputWithValue: anObject callback: callbackBlock
	self valueInputOfType: 'hidden'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
textInputOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		textInputWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 5/6/2003 18:30'!
imageMapWithAction: aBlock form: aForm
	|point actionKey pointKey|
	point _ ValueHolder new.
	pointKey _ callbacks registerCallback: [:ptString | point contents: (self parseImageMap: ptString)].
	actionKey _ callbacks registerActionCallback: [aBlock value: point contents].
	self
		attributeAt: 'href'
		put: actionUrl, '?', actionKey, '&', pointKey, '='.
	self tag: 'a' do: [
		self attributeAt: 'border' put: 0; attributeAt: 'ismap' put: true.
		self imageWithForm: aForm.
	]! !

WAHtmlRenderer subclass: #WAWikiRenderer
	instanceVariableNames: 'linkBlock olLevel consumeCR inParagraph ulLevel lastWasCR '
	classVariableNames: 'SpecialCharacterString SpecialCharacter EmCharacter AngleBrackets EmCharacterString '
	poolDictionaries: ''
	category: 'Seaside/Examples-Wiki'!

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 23:15'!
linkBlock: aBlock
	linkBlock _ aBlock! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 11/25/2002 21:58'!
fixEms: aString
	"Resolve all the emphasizes."

	| start aLine end |
	start _ 1.
	aLine _ aString.
	[(start _ aLine indexOfSubCollection: '_' startingAt: start ifAbsent: [0]) ~= 0
		and: [start < aLine size]]
	whileTrue:
		[(aLine at: start+1) = $_
			ifTrue: [aLine _ aLine copyReplaceFrom: start 
								to: start+1 with: '_'.
					start_start + 1]
			ifFalse: [
				(end _ aLine indexOfSubCollection: '_'
						startingAt: (start+1) ifAbsent: [0]) ~= 0
					ifTrue: [aLine _ aLine copyReplaceFrom: start to: end
							with: ('<b>', (aLine copyFrom: start+1 to: end-1), '</b>')]
					ifFalse: [start _ start + 1]]].
	^aLine! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:32'!
swikifyPiece: aString
	"Swikify the String. The string contains CRs as lineendings but may
	end in a middle of a line, that is why we keep state in instance variables.
	An empty line ends current paragraph if
	a paragraph is in progress, otherwise it generates a <br />.
	Transformations done are:
		CR -> <br />, !! -> h1, !!!! -> h2, !!!!!! -> h3, # -> <ol> , ## -> nested <ol>
		- -> <ul>, -- -> nested <ul>, _something_ -> <b>something</b>
		| -> <hr>
		*something* -> Link to something,
		*textOrImage|something* -> Link to something but showing text or image for link. 

		And then finally also map '&' -> '&amp;' and '**'-> '*'"

	"Map the tricky characters." 
	| string newLevel |
	string _ aString copyReplaceAll: '&' with: '&amp;'.
	(string findTokens: (String with: Character cr with: Character lf) keep: (String with: Character cr)) do: [:aLine |
		(aLine = (String with: Character cr))
			ifFalse: [ "Not a CR"
				"Convert any links in the line"
				aLine _ self fixEms: aLine.
				aLine _ self fixLinks: aLine.

				"Check for special line beginnings"
				consumeCR _ true.
				lastWasCR ifTrue:[
					(aLine beginsWith: '-')
						ifTrue: [self endPossibleParagraph.
								newLevel _ self countLevel: $- in: aLine.
								newLevel > ulLevel
									ifTrue:[(newLevel - ulLevel) timesRepeat: [self openTag: #ul]]
									ifFalse: [(ulLevel - newLevel) timesRepeat: [self close]].
								ulLevel > 0 ifTrue:[self close].
								self openTag: #li; text: (aLine copyFrom: newLevel + 1 to: aLine size).
								ulLevel _ newLevel] ifFalse: [
					self endPossibleUl.
					(aLine beginsWith: '#')
						ifTrue: [self endPossibleParagraph.
								newLevel _ self countLevel: $# in: aLine.
								newLevel > olLevel
									ifTrue:[(newLevel - olLevel) timesRepeat: [self openTag: #ol]]
									ifFalse: [(olLevel - newLevel) timesRepeat: [self closeTag: #ol]].
								olLevel > 0 ifTrue:[self closeTag: #li].
								self openTag: #li; text: (aLine copyFrom: newLevel + 1 to: aLine size).
								olLevel _ newLevel.] ifFalse: [
					self endPossibleOl.
					(aLine beginsWith: '|')
						ifTrue: [self endPossibleParagraph.
								self horizontalRule] ifFalse: [
					(aLine beginsWith: '!!!!!!')
						ifTrue: [self endPossibleParagraph.
								self heading: (aLine copyFrom: 4 to: aLine size) level: 3
					] ifFalse: [
					(aLine beginsWith: '!!!!')
						ifTrue: [self endPossibleParagraph.
								self heading: (aLine copyFrom: 3 to: aLine size) level: 2
					] ifFalse: [
					(aLine beginsWith: '!!')
						ifTrue: [self endPossibleParagraph.
								self heading: (aLine copyFrom: 2 to: aLine size) level: 1
					] ifFalse: [
							consumeCR _ false.
							"Ok, then this is text. If we are not in a paragraph we start one."
							inParagraph
								ifTrue: ["If last was CR we add a break for that until we continue."
										lastWasCR ifTrue:[self break]]
								ifFalse: [(ulLevel + olLevel = 0) ifTrue:[inParagraph _ true. self openTag: #p]].
							self text: aLine]]]]]]]
				ifFalse: [
					consumeCR _ false.
					"Ok, then this is text. If we are not in a paragraph we start one."
					inParagraph
						ifTrue: ["If last was CR we add a break for that until we continue."
								lastWasCR ifTrue:[self break]]
						ifFalse: [(ulLevel + olLevel = 0) ifTrue:[inParagraph _ true. self openTag: #p]].
					self text: aLine].
				lastWasCR _ false]

			 ifTrue: ["A CR"
				"If we are in a paragraph and last was a CR we end it, otherwise we remember this CR."
				consumeCR
					ifTrue: [consumeCR _ false. lastWasCR _ true]
					ifFalse: [
							lastWasCR
								ifTrue:[(self endPossibleUl | self endPossibleOl)
											ifFalse:[
												inParagraph
													ifTrue:[self endPossibleParagraph]
													ifFalse: [self break]]]
								ifFalse:[lastWasCR _ true]]]]! !

!WAWikiRenderer class methodsFor: 'as yet unclassified' stamp: 'ab 11/25/2002 21:55'!
initialize
	AngleBrackets _ CharacterSet newFrom: #($< $>).
	SpecialCharacter _ $*.
	SpecialCharacterString _ SpecialCharacter asString.
	EmCharacter _ $_.
	EmCharacterString _ EmCharacter asString.
! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 23:13'!
resolveLink: aString
	"Resolve the link. Text before an optional '|' is used as the visible string"

	|  parts url string |
	parts _ aString findTokens: '|'.
	parts size = 1
		ifTrue:[url _ string _ aString]
		ifFalse: [url _ parts at: 2. string _ parts at: 1].
	^ '<a href="',(self urlForLink: url),'">',string,'</a>'.! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 18:19'!
endPossibleParagraph
	inParagraph ifTrue: [self close. inParagraph _ false]! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 16:06'!
urlForLink: aString
	^ actionUrl, '?', (callbacks registerActionCallback: [linkBlock value: aString])! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 11/25/2002 21:55'!
countLevel: char in: aLine
	"Start the paragraph."

	| count |
	count _ 0.
	aLine do: [:c | c = char ifTrue:[count _ count + 1] ifFalse: [^count]]! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 18:20'!
endPossibleUl
	^ ulLevel > 0 and: [
		self close.
		ulLevel timesRepeat: [self close].
		ulLevel _ 0.
		true]! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 11/25/2002 22:00'!
swikify: aString
	"Swikify the String. This code only handles cutting up
	the String into pieces based on angle brackets and calling
	#swikifyPiece: for each piece outside of a tag.
	The tag <html></html> is also handled as a way of
	disabling swikification."

	| pos index piece tagLevel finished size ignore |
	aString isEmptyOrNil ifTrue:[^''].
	inParagraph _ finished _ ignore _ false.
	lastWasCR _ true.
	ulLevel _ olLevel _ tagLevel _ index _ 0.
	pos _ 1.
	size _ aString size.
	[finished ifFalse: [index _ aString indexOfAnyOf: AngleBrackets startingAt: pos].
	finished]
		whileFalse: [
			index = 0
				ifTrue:[index _ size. piece _ aString copyFrom: pos to: index]
				ifFalse:[	piece _ aString copyFrom: pos to: index - 1].
			pos _ index + 1.
			(ignore or: [tagLevel > 0])
				ifTrue:["Check special tags"
					(piece = 'html') ifTrue:[ignore _ true] ifFalse:[
					(piece = '/html') ifTrue:[ignore _ false] ifFalse:[
						tagLevel = 0
							ifTrue:[self text: piece]
							ifFalse: [self text: '<', piece, '>'].
						]]]
				ifFalse:[self swikifyPiece: piece].
			((aString at: index) = $<)
				ifTrue: [tagLevel _ tagLevel + 1]
				ifFalse: [tagLevel _ tagLevel - 1].
			finished _ index = size.
		].
	"End any lists"
	self endPossibleUl; endPossibleOl.

	"If we are still in a paragraph we end it."
	self endPossibleParagraph.

	"If we have a hanging CR we add a break."
	consumeCR ifFalse: [lastWasCR ifTrue:[self break. lastWasCR _ false]].! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 18:20'!
endPossibleOl
	^ olLevel > 0 and: [
		self close.
		olLevel timesRepeat: [self close].
		olLevel _ 0.
		true]! !

!WAWikiRenderer methodsFor: 'as yet unclassified' stamp: 'ab 11/25/2002 21:58'!
fixLinks: aString
	"Resolve all the links."

	| start aLine end |
	start _ 1.
	aLine _ aString.
	[(start _ aLine indexOfSubCollection: SpecialCharacterString startingAt: start ifAbsent: [0]) ~= 0
		and: [start < aLine size]]
	whileTrue:
		[(aLine at: start+1) = SpecialCharacter
			ifTrue: [aLine _ aLine copyReplaceFrom: start 
								to: start+1 with: SpecialCharacterString.
					start_start + 1]
			ifFalse: [
				(end _ aLine indexOfSubCollection: SpecialCharacterString
						startingAt: (start+1) ifAbsent: [0]) ~= 0
					ifTrue: [aLine _ aLine copyReplaceFrom: start to: end
							with: (self resolveLink: (aLine copyFrom: start+1 to: end-1))]
					ifFalse: [start _ start + 1]]].
	^aLine! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
anchorOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		anchorWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:31'!
labelledRowForTextInputOn: aSymbol of: anObject
	self labelledRowForTextInputOn: aSymbol of: anObject size: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
checkboxOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		checkboxWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
textAreaOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		textAreaWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 2/12/2003 17:21'!
booleanMenuOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		booleanMenuWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:24'!
linkWithScript: jsString
	self scriptWithUrl: (self urlForDocument: jsString mimeType: 'text/javascript' fileName: nil)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'JF 5/26/2003 09:47'!
openAnchorWithAction: actionBlock
	self
		attributeAt: 'href'
		put: (self urlForAction: actionBlock).
	self openTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'ab 1/11/2003 13:28'!
optionWithLabel: labelString selected: aBoolean callback: callbackBlock
	self 
		attributeAt: 'selected' put: aBoolean;
		attributeAt: 'value' put: (callbacks registerCallback: callbackBlock).
	
	self openTag: 'option'. 
	self text: labelString.
	self close.! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
callbackForSelector: aSymbol of: anObject
	^ MessageSend receiver: anObject selector: (aSymbol copyWith: $:) asSymbol! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'ab 1/11/2003 13:28'!
openSelect
	self attributeAt: 'name' put: callbacks registerDispatchCallback.
	self openTag: 'select'.	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'ab 1/11/2003 13:28'!
defaultAction: actionBlock
	self
		inputWithType: 'hidden'
		named: (callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 2/12/2003 19:40'!
linkWithStyle: cssString
	self styleLinkWithUrl: (self urlForDocument: cssString mimeType: 'text/css')! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'JF 6/2/2003 20:22'!
radioButtonInGroup: radioGroupKey selected: aBoolean callback: callbackBlock
	self attributeAt: 'checked' put: aBoolean.
	
	self inputWithType: 'radio' named: radioGroupKey value: (callbacks registerCallback: callbackBlock)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 4/8/2003 14:25'!
anchorWithAction: actionBlock do: linkBlock
	self openAnchorWithAction: actionBlock.
	linkBlock value.
	self close.

! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'JF 6/2/2003 20:22'!
valueInputOfType: typeString value: anObject callback: callbackBlock
	|updateKey callback value|
	value _ anObject.
	callback _ callbackBlock.
	anObject isNumber ifTrue:
		[anObject isFraction
			ifTrue:
				[value _ anObject asFloat asString.
				callback _ [:v | callbackBlock value:
									(v = value ifTrue: [anObject] ifFalse: [v asNumber])]]
			ifFalse:
				[callback _ [:v | callbackBlock value: v asNumber]]].
	anObject isNil ifTrue:
		[value _ ''.
		callback _ [:v | callbackBlock value: (v = '' ifTrue: [nil] ifFalse: [v])]].
					
	updateKey _ callbacks registerCallback: callback.
	self inputWithType: typeString named: updateKey value: value.
	^ updateKey
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'ab 1/11/2003 13:28'!
callbacks: aCallbacks
	callbacks _ aCallbacks! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForTextAreaOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self textAreaOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
textInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'text'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 2/12/2003 17:21'!
booleanMenuWithValue: aBoolean callback: callbackBlock
	self booleanMenuWithValue: aBoolean callback: callbackBlock labels: #(Yes No)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'jf 11/21/2003 17:09'!
hiddenInputWithCallback: callbackBlock
	self inputWithType: 'hidden' named: (callbacks registerCallback: callbackBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'jf 11/20/2003 16:11'!
radioButtonInGroup: radioGroupKey withValue: value on: aSelector of: anObject
	self
		radioButtonInGroup: radioGroupKey
		selected: (value = (anObject perform: aSelector))
		callback: [:v | anObject perform: aSelector asMutator with: value]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock
	self selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: [:i | i asString]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'ab 1/11/2003 13:28'!
actionUrl: aString
	actionUrl _ aString! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:48'!
styleLinkWithUrl: urlString
	self attributes
		at: 'rel' put: 'stylesheet';
		at: 'type' put: 'text/css';
		at: 'href' put: urlString.
	self headTag: 'link'! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 6/2/2003 19:13'!
formWithAction: actionUrl do: aBlock
	self formWithMethod: 'POST' action: actionUrl do: aBlock! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
heading: aString
	self heading: aString level: 1! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'JF 6/10/2003 18:12'!
layoutTable: aBlock
	self attributes
		border: 0;
		cellspacing: 0;
		cellpadding: 0.
	self table: aBlock! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 6/10/2003 11:36'!
encodeText: anObject
	| encoded |
	encoded _ String streamContents:
		[:s |
		anObject asString do: [:char | s nextPutAll: (HtmlCharacters at: char ifAbsent: [char asString] )]].
	self text: encoded! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
horizontalRule
	self tag: 'hr'! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 6/10/2003 19:20'!
anchorWithUrl: urlString do: aBlock
	self attributes href: urlString.
	self tag: 'a' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 6/2/2003 19:12'!
formWithMethod: methodString action: actionUrl do: aBlock
	self attributes method: methodString;
			action: actionUrl.
	self openTag: 'form'.
	aBlock value.
	self close.! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 7/10/2003 11:30'!
encodeCharacter: aCharacter
	document addElement: ('&#', aCharacter asInteger asString, ';').  ! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:26'!
tableHeadings: aCollection
	self tableRow: [aCollection do: [:ea | self tableHeading: ea]]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph
	self tag: 'p'! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
scriptWithUrl: urlString
	self attributes
		at: 'language' put: 'javascript';
		at: 'src' put: urlString.
	self headTag: 'script'.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/13/2003 00:07'!
emphasis: aBlock
	self tag: 'em' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
underline: aBlock
	self tag: 'u' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
list: aCollection
	self list: aCollection do: [:x | self text: x]! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:04'!
table: aBlock
	self tag: 'table' do: aBlock! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:29'!
tableRowWithLabel: anObject column: aBlock column: anotherBlock
	self tableRow: [
		self cssClass: 'label'.
		self tableData: anObject.
		self tableData: aBlock; tableData: anotherBlock]! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 10/14/2003 11:31'!
formWithUrl: urlString method: methodString do: formBlock
	self attributes
		action: urlString;
		method: methodString.
	self openTag: 'form'.
	formBlock value.
	self close.
! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divNamed: aString with: anObject
	self cssId: aString; div: anObject! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanNamed: aString with: anObject
	self cssId: aString; span: anObject! !

!WAHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'kph 4/4/2003 04:32'!
initialize
	"WAHtmlBuilder initialize"

	HtmlCharacters _ Dictionary new: 128.
	#('quot' $" 'lt' $< 'amp' $& 'gt' $> ) pairsDo:
		[:s :c | HtmlCharacters at: c  put: ('&',s,';') ].
	#('nbsp' 'iexcl' 'cent' 'pound' 'curren' 'yen' 'brvbar' 'sect' 'uml' 'copy' 'ordf' 'laquo' 'not' 'shy' 'reg' 'hibar' 'deg' 'plusmn' 'sup2' 'sup3' 'acute' 'micro' 'para' 'middot' 'cedil' 'sup1' 'ordm' 'raquo' 'frac14' 'frac12' 'frac34' 'iquest' 'Agrave' 'Aacute' 'Acirc' 'Atilde' 'Auml' 'Aring' 'AElig' 'Ccedil' 'Egrave' 'Eacute' 'Ecirc' 'Euml' 'Igrave' 'Iacute' 'Icirc' 'Iuml' 'ETH' 'Ntilde' 'Ograve' 'Oacute' 'Ocirc' 'Otilde' 'Ouml' 'times' 'Oslash' 'Ugrave' 'Uacute' 'Ucirc' 'Uuml' 'Yacute' 'THORN' 'szlig' 'agrave' 'aacute' 'acirc' 'atilde' 'auml' 'aring' 'aelig' 'ccedil' 'egrave' 'eacute' 'ecirc' 'euml' 'igrave' 'iacute' 'icirc' 'iuml' 'eth' 'ntilde' 'ograve' 'oacute' 'ocirc' 'otilde' 'ouml' 'divide' 'oslash' 'ugrave' 'uacute' 'ucirc' 'uuml' 'yacute' 'thorn' 'yuml' ) withIndexDo:
		[:s :i | HtmlCharacters at: (i - 1 + 160) asCharacter put:  ('&',s,';')].  ! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRow: aBlock
	self tag: 'tr' do: aBlock! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
preformatted: anObject
	self tag: 'pre' do: anObject! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 11/24/2003 11:54'!
listItem: aBlock
	self tag: #li do: aBlock! !

!WAHtmlBuilder methodsFor: 'model' stamp: 'ac 9/22/2003 16:35'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 2/12/2003 21:59'!
close
	document popElement ! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
submitButton
	self inputWithType: 'submit'
! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: x with: y with: z
	self tableRow: [ self tableData: x; tableData: y; tableData: z]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
space
	self text: '&nbsp;'! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
bold: aBlock
	self tag: 'b' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 1/11/2003 12:45'!
tag: aString
	self openTag: aString.
	self close.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 5/27/2003 15:13'!
image: urlString width: width height: height
	self attributeAt: 'width' put: width.
	self attributeAt: 'height' put: height.
	
	self image: urlString! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 2/12/2003 21:59'!
text: anObject
	document addElement: anObject asString! !

!WAHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 23:39'!
on: aDocument
	^ self new document: aDocument! !

Object subclass: #WAStoreItem
	instanceVariableNames: 'title subtitle description price '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:17'!
subtitle: aString
	subtitle_ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
title
	^ title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:28'!
price
	^ price! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
title: aString
	title _ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
description
	^ description! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:28'!
price: cents
	price _ cents! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
description: aString
	description _ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:30'!
matches: aString
	^ (title includesSubstring: aString caseSensitive: false)
		or: [description includesSubstring: aString caseSensitive: false]! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:17'!
subtitle
	^ subtitle! !

Object subclass: #SeasidePlatformSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Platform'!

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:18'!
profileSendsDuring: aBlock
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.	
	^ String streamContents: 
			[:stream | 
			(MessageTally new)
				spyEvery: 1
				on: [aBlock value. Smalltalk garbageCollectMost];
				report: stream]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:23'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	SMTPSocket
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: self smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:23'!
smtpServer
	^ 'localhost'! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 14:57'!
vmStatisticsReportString
	^ Utilities vmStatisticsReportString ! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:04'!
mimeDocumentClass
	^ MIMEDocument ! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
base64Decode: aString
	^ (Base64MimeConverter mimeDecodeToChars: aString readStream) contents
		! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:02'!
weakDictionaryOfSize: aNumber
	| dict |
	dict _ WeakIdentityKeyDictionary new: aNumber.
	WeakArray addWeakDependent: dict.
	^ dict! !

Object subclass: #WAStateRegistry
	instanceVariableNames: 'lastSnapshot objects '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-State'!

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:02'!
registerObject: anObject
	objects at: anObject put: anObject shallowCopy! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 00:23'!
snapshot
	| snapshot |
	snapshot := SeasidePlatformSupport weakDictionaryOfSize: objects size.
	objects keysAndValuesDo:
		[:obj :copy|
		(self snapshot: copy isIdenticalTo: obj)
			ifTrue: [snapshot at: obj put: copy]
			ifFalse: [snapshot at: obj put: obj shallowCopy]].
	^ snapshot
! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
size
	^ objects size! !

!WAStateRegistry class methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:38'!
new
	^ super new initialize! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:11'!
snapshot: copy isIdenticalTo: object
	1 to: object class instSize do: [:i | (copy instVarAt: i) == (object instVarAt: i) ifFalse: [^ false]].
	object class isVariable ifTrue:
		[1 to: object size do: [:i | (copy at: i) == (object at: i) ifFalse: [^ false]]].
	^ true! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
restoreSnapshot: aDictionary
	aDictionary keysAndValuesDo:
		[:k :v |
		self restoreObject: k fromSnapshot: v]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:02'!
initialize
	objects _ SeasidePlatformSupport weakDictionaryOfSize: 10.! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:11'!
restoreObject: object fromSnapshot: copy
	1 to: object class instSize do: [:i | object instVarAt: i put: (copy instVarAt: i)].
	object class isVariable ifTrue: [1 to: object size do: [:i | object at: i put: (copy at: i)]].
	objects at: object put: copy.! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:55'!
calculateFootprint
	^ (objects detectSum: [:ea | 2 + ea class instSize + (ea class isVariable ifTrue: [ea size + 1] ifFalse: [0])]) * 4! !

!Date class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:29'!
newDay: dayNumber monthNumber: monthNumber year: yearNumber
	^ self newDay: dayNumber month: monthNumber year: yearNumber! !

!Exception class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 3/28/2003 17:36'!
reactivateHandler 
  handlerContext ifNotNil: [handlerContext tempAt: 3 put: true].
! !

TestCase subclass: #AmbTest
	instanceVariableNames: 'amb '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Tests'!

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 13:33'!
testMaybe
	|x y z|
	x _ amb maybe.
	y _ amb maybe.
	z _ amb maybe not.

	amb deny: x = y.
	amb deny: x = z.
	
	self assert: {x. y. z} = {true. false. false}.	! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/13/2002 01:15'!
setUp
	amb _ Amb new! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumber
	^ self pickANumberGreaterThan: 0! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 03:06'!
testSicpLogicProblemFaster
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"
	
	|baker cooper fletcher miller smith|
	fletcher _ amb oneOf: (1 to: 5).
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.

	smith _ amb oneOf: (1 to: 5).
	amb deny: (smith - fletcher) abs = 1.

	cooper _ amb oneOf: (1 to: 5).
	amb deny: cooper = 1.
	amb deny: (fletcher - cooper) abs = 1.

	miller _ amb oneOf: (1 to: 5).
	amb assert: miller > cooper.

	baker _ amb oneOf: (1 to: 5).
	amb deny: baker = 5.
	
	amb assert: {baker. cooper. fletcher. miller. smith} asSet size = 5.
	self assert: {baker. cooper. fletcher. miller. smith} = #(3 2 4 5 1).! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:21'!
testPickANumberAboveFive
	|x|
	x _ self pickANumber.
	amb assert: (x > 5).
	self assert: x = 6.
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:43'!
testAllValuesAboveFive
	|x results|
	results _ amb allValues:
				[x _ amb oneOf: (1 to: 10).
				amb assert: (x > 5).
				x].			
	self assert: results = #(6 7 8 9 10).
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:27'!
testSolveAnEquation
	|x y|
	x _ amb oneOf: (1 to: 10).
	y _ amb oneOf: (1 to: 10).
	amb assert: (y * x) = 42.
	self assert: x = 6.
	self assert: y = 7.
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumberGreaterThan: aNumber
	^ amb valueOf: [aNumber + 1] or: [self pickANumberGreaterThan: aNumber + 1]! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 13:16'!
testSicpLogicProblem
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"

"This implementation is too slow - uncomment to actually run it."
	
"	|baker cooper fletcher miller smith|
	baker _ amb oneOf: (1 to: 5).
	cooper _ amb oneOf: (1 to: 5).
	fletcher _ amb oneOf: (1 to: 5).
	miller _ amb oneOf: (1 to: 5).
	smith _ amb oneOf: (1 to: 5).
	
	amb assert: {baker. cooper. fletcher. miller. smith} asSet size = 5.
	
	amb deny: baker = 5.
	amb deny: cooper = 1.
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.
	amb assert: miller > cooper.
	amb deny: (smith - fletcher) abs = 1.
	amb deny: (fletcher - cooper) abs = 1.
	
	self assert: {baker. cooper. fletcher. miller. smith} = #(3 2 4 5 1)."! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:21'!
testPickANumber
	self assert: self pickANumber = 1.! !

TestCase subclass: #WAStateRegistryTest
	instanceVariableNames: 'registry '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Tests'!

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
assertSnapshot: x isIdenticalTo: y
	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:23'!
testConsecutiveSnapshots
	|a snap1 snap2 snap3 |
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	snap2 _ registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap2).
	a contents: 2.
	snap3 _ registry snapshot.
	self deny: (self snapshot: snap3 isIdenticalTo: snap2).
	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:16'!
setUp
	registry _ WAStateRegistry new! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:17'!
testRevert
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:21'!
testGarbageCollection
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	Smalltalk garbageCollect.
	self assert: registry size = 1.
	a _ nil.
	Smalltalk garbageCollect.
	self assert: registry size = 0.! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:22'!
testRevertTwice
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	a contents: 3.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:24'!
testNoChangeAfterRestore
	| a snap1 snap2 snap3 |
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	snap2 _ registry snapshot.
	self deny: (self snapshot: snap1 isIdenticalTo: snap2).
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	snap3 _ registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap3).! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
snapshot: x isIdenticalTo: y
	^ ((IdentitySet withAll: x values) includesAllOf: y values).! !

TestCase subclass: #ContinuationTest
	instanceVariableNames: 'tmp tmp2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Tests'!

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockEscape
	|x|
	tmp _ 0.
	x _ [tmp _ tmp + 1. tmp2 value].
	self callcc: [:cc | tmp2 _ cc. x value].
	tmp2 _ [].
	x value.
	self assert: tmp = 2.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockTemps
	|y|
	#(1 2 3) do:
		[:i ||x|
			x _ i.
			tmp ifNil: [tmp2 _ (self callcc: [:cc | tmp _ cc. [:q]])].
			tmp2 value: x.
			x _ 17].
	y _ (self callcc: [:cc | tmp value: cc. 42]).
	self assert: y = 1.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockVars
	|continuation|
	tmp _ 0.
	tmp _ (self callcc: [:cc | continuation _ cc. 0]) + tmp.
	tmp2 
		ifNotNil: [tmp2 value]
		ifNil:
			[#(1 2 3) do:
				[:i |
				self callcc: [:cc | tmp2 _ cc. continuation value: i]]].
	self assert: tmp = 6.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testMethodTemps
	|i continuation|
	i _ 0.
	i _ i + (self callcc: [:cc | continuation _ cc. 1]).
	self assert: i ~= 3.
	i = 2 ifFalse: [continuation value: 2].! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 2/14/2003 01:17'!
testComprehension
	"What should this print out?
	
	|yin yang|
	yin := [:x | Transcript cr. x] value: Continuation current.
	yang := [:x | Transcript nextPut: $*. x] value: Continuation current.
	yin value: yang."! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:27'!
testSimplestCallCC
	|x|
	x _ self callcc: [:cc | cc value: true].
	self assert: x.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
callcc: aBlock
	^ Continuation currentDo: aBlock! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testSimpleCallCC
	|x continuation|
	x _ self callcc: [:cc | continuation _ cc. false].
	x ifFalse: [continuation value: true].
	self assert: x.! !

!Stream methodsFor: '*seaside2-squeak' stamp: 'avi 8/31/2003 15:48'!
closed
	^false! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'ab 11/11/2002 12:06'!
renderOn: html
! !

!Morph methodsFor: '*seaside2-squeak' stamp: 'ab 5/28/2003 23:31'!
asMIMEDocument
	^ self imageForm asMIMEDocument! !

!Dictionary methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Utilities'!

Notification subclass: #WASimulatedRequestNotification
	instanceVariableNames: 'request '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Utilities'!

!WASimulatedRequestNotification methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:07'!
request: aRequest
	request _ aRequest! !

!WASimulatedRequestNotification methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:07'!
request
	^ request! !

!BlockContext methodsFor: '*seaside2' stamp: 'ab 2/11/2003 20:09'!
handleRequest: aRequest
	^ self value: aRequest! !

!BlockContext methodsFor: '*seaside2' stamp: 'ac 5/16/2003 16:30'!
renderOn: aRenderer
	self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]! !

PackageInfo subclass: #Seaside2Info
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Info'!

!Seaside2Info methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 15:42'!
includesSystemCategory: aString
	^ aString beginsWith: 'Seaside/'! !

!Seaside2Info methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 15:41'!
packageName
	^ 'Seaside2'! !

PackageInfo subclass: #SeasideVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Info'!

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 23:10'!
packageName
	^ 'SeasideVW'! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW3
	VW3PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW3.st')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 17:46'!
externalName
	^ 'Seaside'! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 23:16'!
includesSystemCategory: aString
	^ (aString beginsWith: 'Seaside/') and: [(self ignoredCategories includes: (aString copyAfter: $/)) not]! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW5.st')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:01'!
ignoredCategories
	^ #('Base-Info' 'Base-Connections' 'Base-Platform' 'Session-Tests' 'Examples-Tutorial' 'Examples-SM' 'Examples-Wiki' 'Component-Tools-Squeak')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:13'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seaside2')
		and: [(aString endsWith: 'squeak') not]! !

!Form methodsFor: '*seaside2-squeak' stamp: 'ab 5/28/2003 23:30'!
asMIMEDocument 
	^ self asWebImage ! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'ab 7/11/2003 00:10'!
upToAndSkipThroughAll: aCollection
	^ self upToAll: aCollection! !

!Parser methodsFor: '*seaside2-squeak' stamp: 'ab 2/21/2003 02:00'!
interactive

	^ (requestor == nil or: [requestor isKindOf: SyntaxError] or: [requestor isKindOf: WAMethodEditor]) not! !

!String methodsFor: '*seaside2' stamp: 'ab 1/11/2003 12:46'!
printHtmlOn: aStream
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'JF 6/11/2003 13:15'!
renderOn: html indentLevel: level
	html encodeText: self! !

!String methodsFor: '*seaside2' stamp: 'ab 7/3/2003 13:04'!
asMIMEDocument 
	^ SeasidePlatformSupport mimeDocumentClass contentType: 'text/plain' content: self! !

!String methodsFor: '*seaside2' stamp: 'ab 3/29/2003 00:15'!
prettyPrintHtmlOn: aStream indentLevel: aNumber
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'ac 9/22/2003 16:34'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	words _ WriteStream on: String new.
	read _ ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord _ WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x _ read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord _ currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord _ capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents ! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:40'!
evaluateWithArguments: anArray
	^ self valueWithArguments: anArray! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 10/10/2002 01:40'!
fixTemps! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 8/24/2003 16:38'!
valueWithPossibleArgs: anArray 

	self numArgs = 0 ifTrue: [^self value].
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray].
	self numArgs > anArray size ifTrue: [
		^self valueWithArguments: anArray,
				(Array new: (self numArgs - anArray size))
	].
	^self valueWithArguments: (anArray copyFrom: 1 to: self numArgs)

! !

!Collection methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|i|
	i _ 0.
	^ self asArray collect: [:each | i _ i + 1. i -> each]! !

!Integer methodsFor: '*seaside2' stamp: 'ab 6/3/2003 00:58'!
printStringAsCents
	^ '$', (self // 100) asString, '.', (self \\ 100) asTwoCharacterString! !

!Array methodsFor: '*seaside2' stamp: 'ab 10/26/2002 21:26'!
renderOn: html
	self do: [:ea | ea renderOn: html]! !
WACalendarTest initialize!
WACounter initialize!
WADateRangeSelector initialize!
WADispatcherEditor initialize!
WAExampleBrowser initialize!
WAHtmlBuilder initialize!
WAKom initialize!
WAMultiCounter initialize!
WAScreenshot initialize!
WAStoreTask initialize!
WAWikiRenderer initialize!
WAWikiViewer initialize!
WSMFrame initialize!
